/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     extension.c
* initial date:  06/01/2001
* author:        thomas.nussbaumer@gmx.net
*
* description:   handles file to extension mapping
*
* $Id: extension.c,v 1.11 2002/09/23 09:36:35 tnussb Exp $
*
******************************************************************************/

#if defined(LANGUAGE_deutsch) || defined(LANGUAGE_DEUTSCH)
#define MSGDIRECT_COMMENT_STRING   "String"
#define MSGDIRECT_COMMENT_TEXT     "Text"
#define MSGDIRECT_COMMENT_PIC      "Bild"
#define MSGDIRECT_COMMENT_GDB      "Gfx Databank"
#define MSGDIRECT_COMMENT_FIG      "Zeichnung"
#define MSGDIRECT_COMMENT_MACR     "Makro"
#define MSGDIRECT_COMMENT_DATA     "Data"
#define MSGDIRECT_COMMENT_MAT      "Matrix"
#define MSGDIRECT_COMMENT_LIST     "Liste"
#define MSGDIRECT_COMMENT_PRGM     "BASIC Programm"
#define MSGDIRECT_COMMENT_FUNC     "BASIC Funktion"
#define MSGDIRECT_COMMENT_EXE      "NOSTUB Programm"
#define MSGDIRECT_COMMENT_PPG      "Programm (kompr.)"
#define MSGDIRECT_COMMENT_ASM      "KERNEL Programm"
#define MSGDIRECT_COMMENT_LIB      "KERNEL Library"
#define MSGDIRECT_COMMENT_EXPR     "unbekannter Ausdruck"
#define MSGDIRECT_COMMENT_EBOOK    "eBook"
#define MSGDIRECT_COMMENT_ANIM     "Animation"

#elif defined(LANGUAGE_spanish) || defined(LANGUAGE_SPANISH)
#define MSGDIRECT_COMMENT_STRING   "Cadena"
#define MSGDIRECT_COMMENT_TEXT     "Texto"
#define MSGDIRECT_COMMENT_PIC      "Imagen"
#define MSGDIRECT_COMMENT_GDB      "Base de datos de Gfx"
#define MSGDIRECT_COMMENT_FIG      "Figura"
#define MSGDIRECT_COMMENT_MACR     "Macro"
#define MSGDIRECT_COMMENT_DATA     "Datos"
#define MSGDIRECT_COMMENT_MAT      "Matriz"
#define MSGDIRECT_COMMENT_LIST     "Lista"
#define MSGDIRECT_COMMENT_PRGM     "Programa BASIC"
#define MSGDIRECT_COMMENT_FUNC     "Funcion BASIC"
#define MSGDIRECT_COMMENT_EXE      "Programa NOSTUB"
#define MSGDIRECT_COMMENT_PPG      "Programa (comprim.)"
#define MSGDIRECT_COMMENT_ASM      "Programa basado en kernel"
#define MSGDIRECT_COMMENT_LIB      "Libreria de kernel"
#define MSGDIRECT_COMMENT_EXPR     "Expresion desconocida"
#define MSGDIRECT_COMMENT_EBOOK    "Libro electronico"
#define MSGDIRECT_COMMENT_ANIM     "Animation"

#elif defined(LANGUAGE_french) || defined(LANGUAGE_FRENCH)
#define MSGDIRECT_COMMENT_STRING   "Chaine de caracteres"
#define MSGDIRECT_COMMENT_TEXT     "Texte"
#define MSGDIRECT_COMMENT_PIC      "Image"
#define MSGDIRECT_COMMENT_GDB      "Base de donnees GFX"
#define MSGDIRECT_COMMENT_FIG      "Figure"
#define MSGDIRECT_COMMENT_MACR     "Macro"
#define MSGDIRECT_COMMENT_DATA     "Donnees"
#define MSGDIRECT_COMMENT_MAT      "Matrice"
#define MSGDIRECT_COMMENT_LIST     "Liste"
#define MSGDIRECT_COMMENT_PRGM     "Programme BASIC"
#define MSGDIRECT_COMMENT_FUNC     "Fonction BASIC"
#define MSGDIRECT_COMMENT_EXE      "Programme autonome"
#define MSGDIRECT_COMMENT_PPG      "Programme compresse"
#define MSGDIRECT_COMMENT_ASM      "Programme demandant noyau"
#define MSGDIRECT_COMMENT_LIB      "Librairie demandant noyau"
#define MSGDIRECT_COMMENT_EXPR     "Expression inconnue"
#define MSGDIRECT_COMMENT_EBOOK    "Livre electronique"
#define MSGDIRECT_COMMENT_ANIM     "Animation"

#elif defined(LANGUAGE_english) || defined(LANGUAGE_ENGLISH)
#define MSGDIRECT_COMMENT_STRING "String"
#define MSGDIRECT_COMMENT_TEXT   "Text"
#define MSGDIRECT_COMMENT_PIC    "Picture"
#define MSGDIRECT_COMMENT_GDB    "Gfx Database"
#define MSGDIRECT_COMMENT_FIG    "Figure"
#define MSGDIRECT_COMMENT_MACR   "Macro"
#define MSGDIRECT_COMMENT_DATA   "Data"
#define MSGDIRECT_COMMENT_MAT    "Matrix"
#define MSGDIRECT_COMMENT_LIST   "List"
#define MSGDIRECT_COMMENT_PRGM   "BASIC Program"
#define MSGDIRECT_COMMENT_FUNC   "BASIC Function"
#define MSGDIRECT_COMMENT_EXE    "AMS Native Program"
#define MSGDIRECT_COMMENT_PPG    "Program (exepacked)"
#define MSGDIRECT_COMMENT_ASM    "KERNEL Program"
#define MSGDIRECT_COMMENT_LIB    "KERNEL Library"
#define MSGDIRECT_COMMENT_EXPR   "unknown Expression"
#define MSGDIRECT_COMMENT_EBOOK  "eBook"
#define MSGDIRECT_COMMENT_ANIM   "Animation"

#elif defined(LANGUAGE_italian) || defined(LANGUAGE_ITALIAN)
#define MSGDIRECT_COMMENT_STRING   "Stringa"
#define MSGDIRECT_COMMENT_TEXT     "Testo"
#define MSGDIRECT_COMMENT_PIC      "Immagine"
#define MSGDIRECT_COMMENT_GDB      "Database GFX"
#define MSGDIRECT_COMMENT_FIG      "Figura"
#define MSGDIRECT_COMMENT_MACR     "Macro"
#define MSGDIRECT_COMMENT_DATA     "Dati"
#define MSGDIRECT_COMMENT_MAT      "Matrice"
#define MSGDIRECT_COMMENT_LIST     "Lista"
#define MSGDIRECT_COMMENT_PRGM     "Programma BASIC"
#define MSGDIRECT_COMMENT_FUNC     "Funzione BASIC"
#define MSGDIRECT_COMMENT_EXE      "Programma NOSTUB"
#define MSGDIRECT_COMMENT_PPG      "Programma compresso"
#define MSGDIRECT_COMMENT_ASM      "Programma basato su kernel"
#define MSGDIRECT_COMMENT_LIB      "Libreria basata su kernel"
#define MSGDIRECT_COMMENT_EXPR     "Espressione sconosciuta"
#define MSGDIRECT_COMMENT_EBOOK    "eBook"
#define MSGDIRECT_COMMENT_ANIM     "Animazione"

#elif defined(LANGUAGE_portuguese) || defined(LANGUAGE_PORTUGUESE)
#define MSGDIRECT_COMMENT_STRING   "String"
#define MSGDIRECT_COMMENT_TEXT     "Texto"
#define MSGDIRECT_COMMENT_PIC      "Imagem"
#define MSGDIRECT_COMMENT_GDB      "Base de dados Gfx"
#define MSGDIRECT_COMMENT_FIG      "Figura"
#define MSGDIRECT_COMMENT_MACR     "Macro"
#define MSGDIRECT_COMMENT_DATA     "Data"
#define MSGDIRECT_COMMENT_MAT      "Matriz"
#define MSGDIRECT_COMMENT_LIST     "Lista"
#define MSGDIRECT_COMMENT_PRGM     "Programa BASIC"
#define MSGDIRECT_COMMENT_FUNC     "Funcao BASIC"
#define MSGDIRECT_COMMENT_EXE      "Programa NOSTUB"
#define MSGDIRECT_COMMENT_PPG      "Programa (exepacked)"
#define MSGDIRECT_COMMENT_ASM      "Programa kernel-based"
#define MSGDIRECT_COMMENT_LIB      "Biblioteca kernel-based"
#define MSGDIRECT_COMMENT_EXPR     "Expressao desconhecida"
#define MSGDIRECT_COMMENT_EBOOK    "eBook"
#define MSGDIRECT_COMMENT_ANIM     "Animacao"

#else
#error no language defined !!!
#endif

#include <tigcclib.h>
#include "common.h"
#include "extension.h"
#include "pvpicture.h"

/*===========================================================================*/
/* check if given symentry is a TTArchive and if yes, try to extract its     */
/* description, otherwise use default description ("eBook")                  */
/*                                                                           */
/* returns 1 if okay,    0 otherwise                                         */
/*===========================================================================*/
static inline short CheckForEbook(unsigned char* src, file_t* buffer) {
    src+=2;  // skip "length of variable" bytes

    if (!ttarchive_valid(src)) return 0;

    src = ttarchive_info(src);

    if (src) strncpy(buffer->comment,src,TTARCHIVE_INFOLENGTH);
    else     strcpy(buffer->comment,MSGDIRECT_COMMENT_EBOOK);

    buffer->type = TYPE_EBOOK;
    return 1;
}


/*===========================================================================*/
/* checks executable if it is a quill file                                   */
/* returns 1 if quill marker found (sets type and comment)                   */
/*===========================================================================*/
static inline short CheckForQuill(unsigned char* src,unsigned short size,file_t* buffer) {
    unsigned char*       end    = src + ((size < 1024) ? size : 1024);
    short                idx    = 0;
    const unsigned char* marker = "***QUILL***";

    while (src < end) {
        if (*src == marker[idx]) {
            idx++;
        }
        else if (*src == marker[0]) {
            idx = 1;
        }
        else {
            idx = 0;
        }
        src++;
        if (idx == 12) {
            strncpy(buffer->comment,src,MAX_COMMENT);
            buffer->type = TYPE_QUILL;
            return 1;
        }
    }

    return 0;
}


#undef GetDataType
#undef SmapTypeStrings

// SmapTypeStrings:
__ATTR_TIOS__ static __attribute__((__noinline__)) const char * __SmapTypeStringsAMS1xx__(short type)
{
    if (type < 0 || type > 15) return NULL;
    else
    {
        char ** table =  *(char ***)((unsigned char *)_rom_call_addr(319)+140);
        return ((const char *)table[type]);
    }
}

// !AMS_1xx is not usable because I had to set MIN_AMS 205 to be able to use F-Line ROM_CALLs
// without an internal emulator. This made several versions of TICT-Explorer 1.40 unusable on
// AMS 1.xx.
#define GetDataType \
((TIOS_entries >= 1000)?((void *)(_rom_call_addr(435))) \
                       :((void *)(*(unsigned long *)((unsigned char *)_rom_call_addr(319)+134))))

#define SmapTypeStrings \
((TIOS_entries >= 1000)?((void*)(_rom_call_addr(436))) \
                       :((void*)(__SmapTypeStringsAMS1xx__)))



/*===========================================================================*/
/* setups file type                                                          */
/*===========================================================================*/
// Used only once but can't be declared static inline.
void SetFileType(unsigned char* src,file_t* buffer,unsigned short size) {
    register short type asm("%d3");
    register char* tmpext asm("%a4") = NULL;
    register unsigned char* buftypeaddr asm("%a3") = &buffer->type;
    register char* orig_src = src;
    register unsigned char * comment asm("%a2") = buffer->comment;


    src += size-1;
/*
    src += size;
    src--;
*/
    //asm("0: bra.s 0b");

    unsigned char * ptr; // Pointer to function, will be typecast as necessary.
//        type = GetDataType(src);
    ptr = GetDataType;
    if (ptr) {
        type = ((short (__ATTR_TIOS__ *)(CESI))ptr)(src);
    }
    else {
        unsigned char *ptr = (unsigned char*)(&(buffer->ext[0]));
        *ptr++ = 0;
        *ptr++ = 0;
        *ptr++ = 0;
        *ptr++ = 0;
        return;
    }

    if (type == 0) {
        // EXPR.
        // Check for PPIC.
        if (*(src-1) == 0x00) {
            PV_FILE_HEADER* fh = (PV_FILE_HEADER*)(orig_src+2);
            // better candidate for a picture-view picture
            if (fh->magic == PV_MAGIC) {
// Should work the same...
                unsigned short grays = 1<<(fh->nr_planes);
//                unsigned short grays = 2<<(fh->nr_planes-1);
                *buftypeaddr = TYPE_PVPIC;
                tmpext = (char*)"PPIC";
                sprintf(comment,"%s (%uG-%ux%u)",
                    (fh->nr_pics) ? MSGDIRECT_COMMENT_ANIM:MSGDIRECT_COMMENT_PIC,grays,
                    ((PV_PLANE_HEADER*)(orig_src+2+sizeof(PV_FILE_HEADER)))->x_dim << 3,
                    ((PV_PLANE_HEADER*)(orig_src+2+sizeof(PV_FILE_HEADER)))->y_dim);
                goto end;
            }

        }
        goto fallthrough;
    }
    else if (type == 12) {
        unsigned char sb[6];
        //asm("0: bra.s 0b");
        // Special treatment for OTH_TAG.
        src--;
        while (*--src);
        memcpy(sb,src+1,5);
        sb[5] = 0;

        tmpext = sb;
        if (!strcmp(tmpext,"ppg")) {
            *buftypeaddr = TYPE_PPG_EXE;
            strcpy(comment,MSGDIRECT_COMMENT_PPG);
            // TODO: try to extract comments (AMS native standard for comments).
            // Comments will be stored past the end of compressed data.
            // Use work made by Kevin and Samuel.
        }
        else if (!strcmp(tmpext,"ebk")) {
            CheckForEbook(orig_src,buffer);
        }
        else if (!strcmp(tmpext,"SDBF")) {
            *buftypeaddr = TYPE_SCOTTFREE;
            src-=2;
            while (*src--);
            strncpy(comment,src+2,MAX_COMMENT);
        }
        goto end;
    }
    else if (type == 15) {
        // Special treatment for ASM_TAG.
        short is68kP;
        if (((is68kP = (*(unsigned long *)(orig_src+6) == 0x36386B50))) || ((*(unsigned long *)(orig_src+4) == 0x36386341))) {
//        if (!((is68kP = strncmp(orig_src+6,"68kP",4))) || (!strncmp(orig_src+4,"68cA",4))) {
            *buftypeaddr = TYPE_DOORS_EXE;
            tmpext       = (char*)"ASM";
            //---------------------------
            // try to extract comment ...
            //---------------------------
            if ((is68kP) && *(unsigned short*)(orig_src+12)) {
                strncpy(comment,orig_src + 2 + *(unsigned short*)(orig_src+12),MAX_COMMENT);
            }
            else {
                strcpy(comment,MSGDIRECT_COMMENT_ASM);
            }
        }
        else if (*(unsigned long*)(orig_src+6) == 0x36386B4C) {
//        else if (!strncmp(orig_src+6,"68kL",4)) {
            *buftypeaddr = TYPE_DOORS_LIB;
            tmpext       = (char*)"LIB";
            strcpy(comment,MSGDIRECT_COMMENT_LIB);
        }
        else {
            *buftypeaddr = TYPE_AMS_NATIVE_EXE;
            tmpext       = (char*)"EXE";
            if (!CheckForQuill(orig_src,size,buffer)) {
                strcpy(comment,MSGDIRECT_COMMENT_EXE);
            }
            // TODO: try to extract and handle comments (AMS native standard for comments).
            // Use work made by Kevin and Samuel.
        }
        goto end;
    }
    else {
        // The rest.
//        tmpext = (char*)SmapTypeStrings(type);
        ptr = SmapTypeStrings;
        if (ptr) {
            tmpext = ((char * (__ATTR_TIOS__ *)(short))ptr)(type);
        }
        else {
            unsigned char *ptr = (unsigned char*)(&(buffer->ext[0]));
            *ptr++ = 0;
            *ptr++ = 0;
            *ptr++ = 0;
            *ptr++ = 0;
            return;
        }

        switch(type) {
        case SDT_LIST: // 1
            strcpy(comment,MSGDIRECT_COMMENT_LIST);
            break;
        case SDT_MAT: // 2
            strcpy(comment,MSGDIRECT_COMMENT_MAT);
            break;
        case SDT_FUNC: // 3
            *buftypeaddr = TYPE_BASIC;
            // TODO: try to extract and handle comments (TI-Basic comments).
            strcpy(comment,MSGDIRECT_COMMENT_FUNC);
            break;
        case SDT_PRGM: // 4
            *buftypeaddr = TYPE_BASIC;
            // TODO: try to extract and handle comments (TI-Basic comments).
            strcpy(comment,MSGDIRECT_COMMENT_PRGM);
            break;
        case SDT_PIC: // 5
            *buftypeaddr = TYPE_PIC;
            strcpy(comment,MSGDIRECT_COMMENT_PIC);
            break;
        case SDT_STR: // 6
            strcpy(comment,MSGDIRECT_COMMENT_STRING);
            break;
        case SDT_TEXT: // 7
            *buftypeaddr = TYPE_TEXT;
            strcpy(comment,MSGDIRECT_COMMENT_TEXT);
            break;
        case SDT_GDB: // 8
            strcpy(comment,MSGDIRECT_COMMENT_GDB);
            break;
        case SDT_DATA: // 9
            strcpy(comment,MSGDIRECT_COMMENT_DATA);
            break;
        case SDT_FIG: // 10
            strcpy(comment,MSGDIRECT_COMMENT_FIG);
            break;
        case SDT_MAC: // 11
            strcpy(comment,MSGDIRECT_COMMENT_MACR);
            break;

        default:
            goto fallthrough;

        }
        goto end;
    }


    fallthrough:
#if defined(DEBUG_SHOW_FILETAGS)
    unsigned char sb[6];
    tmpext = sb;
    sprintf(sb,"x%02X",*src);
#else
    tmpext = (char*)"EXPR";
#endif
    strcpy(comment,MSGDIRECT_COMMENT_EXPR);

    end:

    // Gives bad code (the compiler tries to be smart but is not).
    // I'm short of ideas to have it do what I want...
    ptr = (unsigned char*)(&(buffer->ext[0]));
    *ptr++ = *tmpext++;
    *ptr++ = *tmpext++;
    *ptr++ = *tmpext++;
    *ptr++ = *tmpext++;
//    memcpy(&(buffer->ext[0]),tmpext,4);
}


// Save working version.
/*
void SetFileType(unsigned char* src,file_t* buffer,unsigned short size) {
    short type;
    register char* tmpext asm("%a4") = NULL;
    register char* buftypeaddr asm("%a3") = &buffer->type;
    char* orig_src = src;
    unsigned char * comment = buffer->comment;

    src += size-1;

    type = GetDataType(src);
    if (type == 0) {
        // EXPR.
        // Check for PPIC.
        if (*(src-1) == 0x00) {
            PV_FILE_HEADER* fh = (PV_FILE_HEADER*)(orig_src+2);
            // better candidate for a picture-view picture
            if (fh->magic == PV_MAGIC) {
// Should work the same...
                unsigned short grays = 1<<(fh->nr_planes);
//                unsigned short grays = 2<<(fh->nr_planes-1);
                *buftypeaddr = TYPE_PVPIC;
                tmpext = (char*)"PPIC";
                sprintf(comment,"%s (%uG-%ux%u)",
                    (fh->nr_pics) ? MSGDIRECT_COMMENT_ANIM:MSGDIRECT_COMMENT_PIC,grays,
                    ((PV_PLANE_HEADER*)(orig_src+2+sizeof(PV_FILE_HEADER)))->x_dim << 3,
                    ((PV_PLANE_HEADER*)(orig_src+2+sizeof(PV_FILE_HEADER)))->y_dim);
            }
        }

        // else fall through !!!
        fallthrough:
#if defined(DEBUG_SHOW_FILETAGS)
        unsigned char sb[6];
        tmpext = sb;
        sprintf(sb,"x%02X",*src);
#else
        strcpy(comment,MSGDIRECT_COMMENT_EXPR);
#endif
    }
    else if (type == 12) {
        unsigned char sb[6];
        // Special treatment for OTH_TAG.
        src-=5;
        if (!*src) memcpy(sb,src+1,3);
        else       memcpy(sb,src,4);
        tmpext = sb;
        if (!strcmp(tmpext,"ppg")) {
            *buftypeaddr = TYPE_PPG_EXE;
            strcpy(comment,MSGDIRECT_COMMENT_PPG);
        }
        else if (!strcmp(tmpext,"ebk")) {
            CheckForEbook(orig_src,buffer);
        }
        else if (!strcmp(tmpext,"SDBF")) {
            *buftypeaddr = TYPE_SCOTTFREE;
            src-=2;
            while (*src--);
            strncpy(comment,src+2,MAX_COMMENT);
        }
    }
    else if (type == 15) {
        // Special treatment for ASM_TAG.
        short is68kP;
        if (!((is68kP = strncmp(orig_src+6,"68kP",4))) || (!strncmp(orig_src+4,"68cA",4))) {
            *buftypeaddr = TYPE_DOORS_EXE;
            tmpext       = (char*)"ASM";
            //---------------------------
            // try to extract comment ...
            //---------------------------
            if ((is68kP) && *(unsigned short*)(orig_src+12)) {
                strncpy(comment,orig_src + 2 + *(unsigned short*)(orig_src+12),MAX_COMMENT);
            }
            else {
                strcpy(comment,MSGDIRECT_COMMENT_ASM);
            }
        }
        else if (!strncmp(orig_src+6,"68kL",4)) {
            *buftypeaddr = TYPE_DOORS_LIB;
            tmpext       = (char*)"LIB";
            strcpy(comment,MSGDIRECT_COMMENT_LIB);
        }
        else {
            *buftypeaddr = TYPE_AMS_NATIVE_EXE;
            tmpext       = (char*)"EXE";
            if (!CheckForQuill(orig_src,size,buffer)) {
                strcpy(comment,MSGDIRECT_COMMENT_EXE);
            }
            // TODO: try to extract comment (AMS native standard for comments).
        }
    }
    else {
        // The rest.
        tmpext = (char*)SmapTypeStrings(type);
        switch(type) {
        case SDT_LIST: // 1
            strcpy(comment,MSGDIRECT_COMMENT_LIST);
            break;
        case SDT_MAT: // 2
            strcpy(comment,MSGDIRECT_COMMENT_MAT);
            break;
        case SDT_FUNC: // 3
            *buftypeaddr = TYPE_BASIC;
            strcpy(comment,MSGDIRECT_COMMENT_FUNC);
            break;
        case SDT_PRGM: // 4
            *buftypeaddr = TYPE_BASIC;
            strcpy(comment,MSGDIRECT_COMMENT_PRGM);
            break;
        case SDT_PIC: // 5
            *buftypeaddr = TYPE_PIC;
            strcpy(comment,MSGDIRECT_COMMENT_PIC);
            break;
        case SDT_STR: // 6
            strcpy(comment,MSGDIRECT_COMMENT_STRING);
            break;
        case SDT_TEXT: // 7
            *buftypeaddr = TYPE_TEXT;
            strcpy(comment,MSGDIRECT_COMMENT_TEXT);
            break;
        case SDT_GDB: // 8
            strcpy(comment,MSGDIRECT_COMMENT_GDB);
            break;
        case SDT_DATA: // 9
            strcpy(comment,MSGDIRECT_COMMENT_DATA);
            break;
        case SDT_FIG: // 10
            strcpy(comment,MSGDIRECT_COMMENT_FIG);
            break;
        case SDT_MAC: // 11
            strcpy(comment,MSGDIRECT_COMMENT_MACR);
            break;

        default:
            goto fallthrough;

        }
    }

//    // Not very efficient, but necessary to get rid of
//    // misalignment problems...
    unsigned char *ptr = (unsigned char*)(&(buffer->ext[0]));
    *ptr++ = *tmpext++;
    *ptr++ = *tmpext++;
    *ptr++ = *tmpext++;
    *ptr++ = *tmpext++;
//    memcpy(&(buffer->ext[0]),tmpext,4);
}
*/




// Older bigger version.
/*
void SetFileType(unsigned char* src,file_t* buffer,unsigned short size) {
    const char* tmpext;
    char  sb[5];
    char* orig_src = src;
    unsigned char * comment = buffer->comment;

    src += size-1;

    memset(sb,0,5);

    switch(*src) {
        // We could use SmapTypeStrings(GetDataType( for most types.
        // That would take advantage of language localizations for
        // tmpext on AMS 2.xx, but I don't know if that would save space
        // (especially since these functions are wrapped on AMS 1.xx).
        // Comments could also be replaced by using DataTypeNames(, but
        // that would be less interesting than the other change.
        // Commented numbers are corresponding items in SystemDataTypes.
        case STR_TAG: // 6
            tmpext = "STR";
            strcpy(comment,MSGDIRECT_COMMENT_STRING);
            break;
        case TEXT_TAG: // 7
            buffer->type = TYPE_TEXT;
            tmpext = "TEXT";
            strcpy(comment,MSGDIRECT_COMMENT_TEXT);
            break;
        case PIC_TAG: // 5
            buffer->type = TYPE_PIC;
            tmpext = "PIC";
            strcpy(comment,MSGDIRECT_COMMENT_PIC);
            break;
        case GDB_TAG: // 8
            tmpext = "GDB";
            strcpy(comment,MSGDIRECT_COMMENT_GDB);
            break;
        case FIG_TAG: // 10
            tmpext = "FIG";
            strcpy(comment,MSGDIRECT_COMMENT_FIG);
            break;
        case MAC_TAG: // 11
            tmpext = "MACR";
            strcpy(comment,MSGDIRECT_COMMENT_MACR);
            break;
        case DATA_TAG: // 9
            tmpext = "DATA";
            strcpy(comment,MSGDIRECT_COMMENT_DATA);
            break;
        case LIST_TAG: // 1, 2
            if (*(src-1) == LIST_TAG) {
                tmpext = "MAT";
                strcpy(comment,MSGDIRECT_COMMENT_MAT);
            }
            else {
                tmpext = "LIST";
                strcpy(comment,MSGDIRECT_COMMENT_LIST);
            }
            break;
        case FUNC_TAG: // 3, 4
            buffer->type = TYPE_BASIC;
            if (IsPRGMVar(src,src-size+1)) {
                tmpext = "PRGM";
                strcpy(comment,MSGDIRECT_COMMENT_PRGM);
            }
            else {
                tmpext = "FUNC";
                strcpy(comment,MSGDIRECT_COMMENT_FUNC);
            }
            break;
        case OTH_TAG: // 12, special treatment
            src-=5;
            if (!*src) memcpy(sb,src+1,3);
            else       memcpy(sb,src,4);
            tmpext = sb;
            if (!strcmp(sb,"ppg")) {
                buffer->type = TYPE_PPG_EXE;
                strcpy(comment,MSGDIRECT_COMMENT_PPG);
            }
            else if (!strcmp(sb,"ebk")) {
                CheckForEbook(orig_src,buffer);
            }
            else if (!strcmp(sb,"SDBF")) {
                buffer->type = TYPE_SCOTTFREE;
                src-=2;
                while (*src--);
                strncpy(comment,src+2,MAX_COMMENT);
            }
            break;
        case ASM_TAG: // 15, special treatment
            if ((!strncmp(orig_src+6,"68kP",4)) || (!strncmp(orig_src+4,"68cA",4))) {
                tmpext       = "ASM";
                buffer->type = TYPE_DOORS_EXE;
                //---------------------------
                // try to extract comment ...
                //---------------------------
                if ((!strncmp(orig_src+6,"68kP",4)) && *(unsigned short*)(orig_src+12)) {
                    strncpy(comment,orig_src + 2 + *(unsigned short*)(orig_src+12),MAX_COMMENT);
                }
                else {
                    strcpy(comment,MSGDIRECT_COMMENT_ASM);
                }
                break;
            }
            else if (!strncmp(orig_src+6,"68kL",4)) {
                tmpext       = "LIB";
                buffer->type = TYPE_DOORS_LIB;
                strcpy(comment,MSGDIRECT_COMMENT_LIB);
                break;
            }
            else {
                tmpext        = "EXE";
                buffer->type  = TYPE_AMS_NATIVE_EXE;
                if (!CheckForQuill(orig_src,size,buffer)) {
                    strcpy(comment,MSGDIRECT_COMMENT_EXE);
                }
                break;
            }
        case 0x00:  // may be a picture-view picture // special treatment
            if (*(src-1) == 0x00) {
                PV_FILE_HEADER* fh = (PV_FILE_HEADER*)(orig_src+2);
                // better candidate for a picture-view picture
                if (fh->magic == PV_MAGIC) {
                    unsigned short grays = 2<<(fh->nr_planes-1);
                    tmpext = "PPIC";
                    buffer->type = TYPE_PVPIC;
                    sprintf(comment,"%s (%uG-%ux%u)",
                            (fh->nr_pics) ? MSGDIRECT_COMMENT_ANIM:MSGDIRECT_COMMENT_PIC,grays,
                            ((PV_PLANE_HEADER*)(orig_src+2+sizeof(PV_FILE_HEADER)))->x_dim << 3,
                            ((PV_PLANE_HEADER*)(orig_src+2+sizeof(PV_FILE_HEADER)))->y_dim);
                    break;
                }
            }

            // else fall through !!!
        default: // 0
#if defined(DEBUG_SHOW_FILETAGS)
            tmpext = sb;
            sprintf(sb,"x%02X",*src);
            break;
#else
            tmpext = "EXPR";
            strcpy(comment,MSGDIRECT_COMMENT_EXPR);
            break;
#endif

    }

    // Not very efficient, but necessary to get rid of
    // misalignment problems...
    memcpy(&(buffer->ext[0]),tmpext,4);
}
*/


//=============================================================================
// Revision History
//=============================================================================
//
// $Log: extension.c,v $
// Revision 1.11  2002/09/23 09:36:35  tnussb
// PreOS's pack archives are now recognized correctly
//
// Revision 1.10  2002/09/10 11:28:41  tnussb
// changes up to v1.30 Beta 4 / examine history.txt for details
//
// Revision 1.9  2002/03/15 15:05:26  tnussb
// path to ttarchive changed (now in subfolder tts)
//
// Revision 1.8  2002/02/07 18:01:17  tnussb
// generic commit
//
// Revision 1.7  2001/02/10 10:22:59  Thomas Nussbaumer
// more strings replaced by defines
//
// Revision 1.6  2001/02/04 13:11:27  Thomas Nussbaumer
// changes up to version 1.00 RC2 (see history.txt)
//
// Revision 1.5  2001/01/26 21:04:44  Thomas Nussbaumer
// changes for version 0.80 [see history.txt]
//
// Revision 1.4  2001/01/21 17:05:09  Thomas Nussbaumer
// changes related to v0.65
//
// Revision 1.3  2001/01/17 23:38:41  Thomas Nussbaumer
// changes related to version 0.50 (see history.txt)
//
// Revision 1.2  2001/01/15 00:08:19  Thomas Nussbaumer
// see history.txt (up to v0.34) for what's new
//
// Revision 1.1  2001/01/06 23:09:46  Thomas Nussbaumer
// initial version
//
//
