/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     file.c
* initial date:  03/01/2001
* author:        thomas.nussbaumer@gmx.net
*
* description:   file handling functionalities
*
* $Id: file.c,v 1.12 2002/09/23 09:37:38 tnussb Exp $
*
******************************************************************************/

#if defined(LANGUAGE_deutsch) || defined(LANGUAGE_DEUTSCH)
#define MSGDIRECT_PLEASESELECT           "Keine Datei selektiert oder markiert"
#define MSGDIRECT_PROCESSARCHIVE         "bearbeite (De-)Archivierung ..."
#define MSGDIRECT_PROCESSLOCKING         "bearbeite (Ent-)Sperren ..."
#define MSGDIRECT_CURRENTINUSE           "ERR: %s in Verwendung"
#define MSGDIRECT_LOCKEDORARCHIVED       "ERR: Datei %s gesperrt oder archiviert"
#define MSGDIRECT_UNARCHIVEFAILED        "ERR: De-Archivierung fehlgeschlagen"
#define MSGDIRECT_ARCHIVEFAILED          "ERR: Archivierung fehlgeschlagen"
#define MSGDIRECT_NOFILEPROCESSED        "Keine Datei bearbeitet"
#define MSGDIRECT_ONEFILEPROCESSED       "1 Datei bearbeitet"
#define MSGDIRECT_MULTIFILEPROCESSED     "%d Dateien bearbeitet"
#define MSGDIRECT_ENTERFOLDERTOCREATE    "Bitte Ordnernamen eingeben"
#define MSGDIRECT_FOLDERNAME             "Ordnername:"
#define MSGDIRECT_STARTWITHLETTER        "ERR: ungueltiger Ordnername"
#define MSGDIRECT_FOLDEREXISTS           "ERR: Ordner existiert bereits"
#define MSGDIRECT_FOLDERCREATIONFAILED   "ERR: Kann Ordner nicht erzeugen"
#define MSGDIRECT_FOLDERSUCCESS          "Ordner %s erfolgreich erzeugt"
#define MSGDIRECT_FOLDERNOTFOUND         "ERR: Ordner %s nicht gefunden"
#define MSGDIRECT_FOLDERNOTEMPTY         "ERR: Ordner nicht leer"
#define MSGDIRECT_CANNOTDELETEMAIN       "ERR: Kann Ordner main nicht loeschen"
#define MSGDIRECT_REQUEST                "Sicherheitsabfrage"
#define MSGDIRECT_SURETODELETEFOLDER     "Aktiven Ordner loeschen?"
#define MSGDIRECT_SUCCESSDELFOLDER       "Ordner %s geloescht"
#define MSGDIRECT_FAILEDDELFOLDER        "Loeschen des Ordners %s fehlgeschlagen"
#define MSGDIRECT_SUREDELACTIVE          "Aktive Datei loeschen?"
#define MSGDIRECT_SUREDELMARKED          "Markierte Dateien loeschen?"
#define MSGDIRECT_FAILEDDELFILE          "ERR: Loeschen von %s fehlgeschlagen"
#define MSGDIRECT_SUCESSDELFILE          "Datei %s geloescht"
#define MSGDIRECT_SUCESSDELONEFILE       "1 Datei geloescht"
#define MSGDIRECT_SUCESSDELMULTIFILE     "%d Dateien geloescht"
#define MSGDIRECT_FILENAMEEXISTS         "ERR: %s existiert bereits"
#define MSGDIRECT_CANNOTOPENFILE         "ERR: kann %s nicht oeffnen"
#define MSGDIRECT_CANNOTCREATEFILE       "ERR: kann %s nicht erzeugen"
#define MSGDIRECT_SELECTDESTINATION      "Ziel-Ordner auswaehlen"
#define MSGDIRECT_COPYTO                 "Kopieren nach:"
#define MSGDIRECT_MOVETO                 "Verschieben nach:"
#define MSGDIRECT_COPYMSGPOSTFIX         "kopiert"
#define MSGDIRECT_MOVEMSGPOSTFIX         "verschoben"
#define MSGDIRECT_FILE_POSTFIX_TO_FILE   "%s %s nach %s"
#define MSGDIRECT_ONEFILE_POSTFIX        "1 Datei %s"
#define MSGDIRECT_MULTIFILE_POSTFIX      "%d Dateien %s"
#define MSGDIRECT_FAILEDMOVEFILE         "ERR: Verschieben von %s fehlgeschlagen"
#define MSGDIRECT_ENTERNEWFILENAME       "Neuen Dateinamen eingeben"
#define MSGDIRECT_CANNOTRENAMEMAIN       "ERR: Main kann nicht umbenannt werden"
#define MSGDIRECT_ENTERNEWFOLDERNAME     "Neuen Ordnernamen eingeben"
#define MSGDIRECT_NEWNAME                "Neuer Name:"
#define MSGDIRECT_INVALIDFILENAME        "ERR: ungueltiger Dateiname"
#define MSGDIRECT_INVALIDFOLDERNAME      "ERR: ungueltiger Ordnername"
#define MSGDIRECT_FAILEDRENAME           "ERR: Umbenennen von %s fehlgeschlagen"
#define MSGDIRECT_SUCCESSRENAME          "%s umbenannt in %s"
#define MSGDIRECT_SYSTEMFILE             "ERR: Systemdatei"

#elif defined(LANGUAGE_spanish) || defined(LANGUAGE_SPANISH)
#define MSGDIRECT_PLEASESELECT           "Por favor seleccione un fichero"
#define MSGDIRECT_PROCESSARCHIVE         "(Des-)Archivando ..."
#define MSGDIRECT_PROCESSLOCKING         "(Des-)bloqueando ..."
#define MSGDIRECT_CURRENTINUSE           "ERR: %s esta en uso"
#define MSGDIRECT_LOCKEDORARCHIVED       "ERR: fichero %s esta bloq. o arch."
#define MSGDIRECT_UNARCHIVEFAILED        "ERR: desarchivado incorrecto"
#define MSGDIRECT_ARCHIVEFAILED          "ERR: archivado correcto"
#define MSGDIRECT_NOFILEPROCESSED        "Ningun fichero procesado"
#define MSGDIRECT_ONEFILEPROCESSED       "1 fichero procesado"
#define MSGDIRECT_MULTIFILEPROCESSED     "%d ficheros procesados"
#define MSGDIRECT_ENTERFOLDERTOCREATE    "Introduce Nombre de la Carpeta"
#define MSGDIRECT_FOLDERNAME             "Nombre carp:"
#define MSGDIRECT_STARTWITHLETTER        "ERR: carpetas DEBEN empezar por letra"
#define MSGDIRECT_FOLDEREXISTS           "ERR: carpeta ya existente"
#define MSGDIRECT_FOLDERCREATIONFAILED   "ERR: creacion de carpeta fallida"
#define MSGDIRECT_FOLDERSUCCESS          "Carpeta %s creada correctamente"
#define MSGDIRECT_FOLDERNOTFOUND         "ERR: no puedo encontrar la carpeta %s"
#define MSGDIRECT_FOLDERNOTEMPTY         "ERR: no se puede eliminar carpeta no vacia"
#define MSGDIRECT_CANNOTDELETEMAIN       "ERR: no se puede eliminar carpeta main"
#define MSGDIRECT_REQUEST                "Peticion"
#define MSGDIRECT_SURETODELETEFOLDER     "Eliminar Carpeta Activa?"
#define MSGDIRECT_SUCCESSDELFOLDER       "Carpeta %s eliminada"
#define MSGDIRECT_FAILEDDELFOLDER        "Eliminacion de carpeta %s fallida"
#define MSGDIRECT_SUREDELACTIVE          "Eliminar Fichero activo?"
#define MSGDIRECT_SUREDELMARKED          "Eliminar Ficheros marcados?"
#define MSGDIRECT_FAILEDDELFILE          "ERR: eliminacin de %s fallida"
#define MSGDIRECT_SUCESSDELFILE          "Fichero %s eliminado"
#define MSGDIRECT_SUCESSDELONEFILE       "1 fichero eliminado"
#define MSGDIRECT_SUCESSDELMULTIFILE     "%d ficheros eliminados"
#define MSGDIRECT_FILENAMEEXISTS         "ERR: %s ya existe"
#define MSGDIRECT_CANNOTOPENFILE         "ERR: no puedo abrir %s"
#define MSGDIRECT_CANNOTCREATEFILE       "ERR: no puedo crear %s"
#define MSGDIRECT_SELECTDESTINATION      "Selecciona Carpeta Destino"
#define MSGDIRECT_COPYTO                 "Copiar a:"
#define MSGDIRECT_MOVETO                 "Mover a:"
#define MSGDIRECT_COPYMSGPOSTFIX         "copiado"
#define MSGDIRECT_MOVEMSGPOSTFIX         "movido"
#define MSGDIRECT_FILE_POSTFIX_TO_FILE   "%s %s a %s"
#define MSGDIRECT_ONEFILE_POSTFIX        "1 fichero %s"
#define MSGDIRECT_MULTIFILE_POSTFIX      "%d ficheros %s"
#define MSGDIRECT_FAILEDMOVEFILE         "ERR: mover %s a %s fallido"
#define MSGDIRECT_ENTERNEWFILENAME       "Introduce nuevo nombre"
#define MSGDIRECT_CANNOTRENAMEMAIN       "ERR: no se puede renombrar carpeta main"
#define MSGDIRECT_ENTERNEWFOLDERNAME     "Introduce nuevo nombre"
#define MSGDIRECT_NEWNAME                "Nombre:"
#define MSGDIRECT_INVALIDFILENAME        "ERR: nombre de fichero no valido"
#define MSGDIRECT_INVALIDFOLDERNAME      "ERR: nombre de carpeta no valido"
#define MSGDIRECT_FAILEDRENAME           "ERR: renombrar %s a %s fallido"
#define MSGDIRECT_SUCCESSRENAME          "%s renombrado a %s"
#define MSGDIRECT_SYSTEMFILE             "ERR: archivo de sistema"

#elif defined(LANGUAGE_french) || defined(LANGUAGE_FRENCH)
#define MSGDIRECT_PLEASESELECT           "Selectionner ou surligner un fichier"
#define MSGDIRECT_PROCESSARCHIVE         "(des)archivage en cours ..."
#define MSGDIRECT_PROCESSLOCKING         "(de)verrouillage en cours ..."
#define MSGDIRECT_CURRENTINUSE           "ERR: %s deja utilise"
#define MSGDIRECT_LOCKEDORARCHIVED       "ERR: fichier %s verrouille ou archive"
#define MSGDIRECT_UNARCHIVEFAILED        "ERR: echec desarchivage"
#define MSGDIRECT_ARCHIVEFAILED          "ERR: echec archivage"
#define MSGDIRECT_NOFILEPROCESSED        "aucun fichier traite"
#define MSGDIRECT_ONEFILEPROCESSED       "1 fichier traite"
#define MSGDIRECT_MULTIFILEPROCESSED     "%d fichiers traites"
#define MSGDIRECT_ENTERFOLDERTOCREATE    "entrer le nom du dossier a creer"
#define MSGDIRECT_FOLDERNAME             "nom dossier:"
#define MSGDIRECT_STARTWITHLETTER        "ERR: le nom doit debuter par une lettre"
#define MSGDIRECT_FOLDEREXISTS           "ERR: le dossier existe deja"
#define MSGDIRECT_FOLDERCREATIONFAILED   "ERR: echec creation de dossier"
#define MSGDIRECT_FOLDERSUCCESS          "dossier %s cree avec succes"
#define MSGDIRECT_FOLDERNOTFOUND         "ERR: dossier %s introuvable"
#define MSGDIRECT_FOLDERNOTEMPTY         "ERR: impossible effacer dossier non vide"
#define MSGDIRECT_CANNOTDELETEMAIN       "ERR: impossible effacer dossier main"
#define MSGDIRECT_REQUEST                "Confirmation"
#define MSGDIRECT_SURETODELETEFOLDER     "Effacer le dossier surligne?"
#define MSGDIRECT_SUCCESSDELFOLDER       "dossier %s efface"
#define MSGDIRECT_FAILEDDELFOLDER        "echec effacement dossier %s"
#define MSGDIRECT_SUREDELACTIVE          "Effacer le fichier surligne?"
#define MSGDIRECT_SUREDELMARKED          "Effacer les fichiers marques?"
#define MSGDIRECT_FAILEDDELFILE          "ERR: echec effacement de %s"
#define MSGDIRECT_SUCESSDELFILE          "fichier %s efface"
#define MSGDIRECT_SUCESSDELONEFILE       "1 fichier efface"
#define MSGDIRECT_SUCESSDELMULTIFILE     "%d fichiers effaces"
#define MSGDIRECT_FILENAMEEXISTS         "ERR: %s existe deja"
#define MSGDIRECT_CANNOTOPENFILE         "ERR: echec ouverture %s"
#define MSGDIRECT_CANNOTCREATEFILE       "ERR: echec creation %s"
#define MSGDIRECT_SELECTDESTINATION      "selectionner dossier destination"
#define MSGDIRECT_COPYTO                 "Copier vers:"
#define MSGDIRECT_MOVETO                 "Deplacer vers:"
#define MSGDIRECT_COPYMSGPOSTFIX         "copie"
#define MSGDIRECT_MOVEMSGPOSTFIX         "deplace"
#define MSGDIRECT_FILE_POSTFIX_TO_FILE   "%s %s vers %s"
#define MSGDIRECT_ONEFILE_POSTFIX        "1 fichier %s"
#define MSGDIRECT_MULTIFILE_POSTFIX      "%d fichiers %s"
#define MSGDIRECT_FAILEDMOVEFILE         "ERR: echec deplacement %s vers %s"
#define MSGDIRECT_ENTERNEWFILENAME       "Entrer nouveau nom de fichier"
#define MSGDIRECT_CANNOTRENAMEMAIN       "ERR: impossible renommer dossier main"
#define MSGDIRECT_ENTERNEWFOLDERNAME     "Entrer nouveau nom de dossier"
#define MSGDIRECT_NEWNAME                "Nouveau nom:"
#define MSGDIRECT_INVALIDFILENAME        "ERR: nom de fichier invalide"
#define MSGDIRECT_INVALIDFOLDERNAME      "ERR: nom de dossier invalide"
#define MSGDIRECT_FAILEDRENAME           "ERR: echec changement de nom %s en %s"
#define MSGDIRECT_SUCCESSRENAME          "%s renomme en %s"
#define MSGDIRECT_SYSTEMFILE             "ERR: fichier systeme"

#elif defined(LANGUAGE_english) || defined(LANGUAGE_ENGLISH)
#define MSGDIRECT_PLEASESELECT         "Please select or highlight a file"
#define MSGDIRECT_PROCESSARCHIVE       "process (un)archiving ..."
#define MSGDIRECT_PROCESSLOCKING       "process (un)locking ..."
#define MSGDIRECT_CURRENTINUSE         "ERR: %s is currently in use"
#define MSGDIRECT_LOCKEDORARCHIVED     "ERR: file %s is locked or archived"
#define MSGDIRECT_UNARCHIVEFAILED      "ERR: unarchiving failed"
#define MSGDIRECT_ARCHIVEFAILED        "ERR: archiving failed"
#define MSGDIRECT_NOFILEPROCESSED      "NO files processed"
#define MSGDIRECT_ONEFILEPROCESSED     "1 file processed"
#define MSGDIRECT_MULTIFILEPROCESSED   "%d files processed"
#define MSGDIRECT_ENTERFOLDERTOCREATE  "Enter Folder Name to Create"
#define MSGDIRECT_FOLDERNAME           "Foldername:"
#define MSGDIRECT_STARTWITHLETTER      "ERR: folders MUST start with a letter"
#define MSGDIRECT_FOLDEREXISTS         "ERR: folder already exists"
#define MSGDIRECT_FOLDERCREATIONFAILED "ERR: folder creation failed"
#define MSGDIRECT_FOLDERSUCCESS        "Folder %s successfully created"
#define MSGDIRECT_FOLDERNOTFOUND       "ERR: cannot find folder %s"
#define MSGDIRECT_FOLDERNOTEMPTY       "ERR: cannot delete non-empty folder"
#define MSGDIRECT_CANNOTDELETEMAIN     "ERR: cannot delete main folder"
#define MSGDIRECT_REQUEST              "Request"
#define MSGDIRECT_SURETODELETEFOLDER   "Sure to Delete Active Folder?"
#define MSGDIRECT_SUCCESSDELFOLDER     "folder %s deleted"
#define MSGDIRECT_FAILEDDELFOLDER      "deleting folder %s failed"
#define MSGDIRECT_SUREDELACTIVE        "Sure to Delete Active File?"
#define MSGDIRECT_SUREDELMARKED        "Sure to Delete Marked Files?"
#define MSGDIRECT_FAILEDDELFILE        "ERR: deleting %s failed"
#define MSGDIRECT_SUCESSDELFILE        "file %s deleted"
#define MSGDIRECT_SUCESSDELONEFILE     "1 file deleted"
#define MSGDIRECT_SUCESSDELMULTIFILE   "%d files deleted"
#define MSGDIRECT_FILENAMEEXISTS       "ERR: %s already exists"
#define MSGDIRECT_CANNOTOPENFILE       "ERR: cannot open %s"
#define MSGDIRECT_CANNOTCREATEFILE     "ERR: cannot create %s"
#define MSGDIRECT_SELECTDESTINATION    "Select Destination Folder"
#define MSGDIRECT_COPYTO               "Copy To:"
#define MSGDIRECT_MOVETO               "Move To:"
#define MSGDIRECT_COPYMSGPOSTFIX       "copied"
#define MSGDIRECT_MOVEMSGPOSTFIX       "moved"
#define MSGDIRECT_FILE_POSTFIX_TO_FILE "%s %s to %s"
#define MSGDIRECT_ONEFILE_POSTFIX      "1 file %s"
#define MSGDIRECT_MULTIFILE_POSTFIX    "%d files %s"
#define MSGDIRECT_FAILEDMOVEFILE       "ERR: moving %s to %s failed"
#define MSGDIRECT_ENTERNEWFILENAME     "Enter New Name for File"
#define MSGDIRECT_CANNOTRENAMEMAIN     "ERR: cannot rename main folder"
#define MSGDIRECT_ENTERNEWFOLDERNAME   "Enter New Name for Folder"
#define MSGDIRECT_NEWNAME              "New Name:"
#define MSGDIRECT_INVALIDFILENAME      "ERR: invalid file name"
#define MSGDIRECT_INVALIDFOLDERNAME    "ERR: invalid folder name"
#define MSGDIRECT_FAILEDRENAME         "ERR: renaming %s to %s failed"
#define MSGDIRECT_SUCCESSRENAME        "%s renamed to %s"
#define MSGDIRECT_SYSTEMFILE           "ERR: system file"

#elif defined(LANGUAGE_italian) || defined(LANGUAGE_ITALIAN)
#define MSGDIRECT_PLEASESELECT           "Selezionare un file"
#define MSGDIRECT_PROCESSARCHIVE         "(De)archiviazione in corso ..."
#define MSGDIRECT_PROCESSLOCKING         "(S)bloccaggio in corso ..."
#define MSGDIRECT_CURRENTINUSE           "ERR: %s in uso"
#define MSGDIRECT_LOCKEDORARCHIVED       "ERR: file %s bloccato o archiviato"
#define MSGDIRECT_UNARCHIVEFAILED        "ERR: de-archiviazione falliata"
#define MSGDIRECT_ARCHIVEFAILED          "ERR: archiviazione fallita"
#define MSGDIRECT_NOFILEPROCESSED        "nessun file trattato"
#define MSGDIRECT_ONEFILEPROCESSED       "1 file trattato"
#define MSGDIRECT_MULTIFILEPROCESSED     "%d file trattati"
#define MSGDIRECT_ENTERFOLDERTOCREATE    "Nome Nuova Cartella da Creare"
#define MSGDIRECT_FOLDERNAME             "Nome:"
#define MSGDIRECT_STARTWITHLETTER        "ERR: il nome DEVE iniziare con una lettera"
#define MSGDIRECT_FOLDEREXISTS           "ERR: la cartella esiste gi"
#define MSGDIRECT_FOLDERCREATIONFAILED   "ERR: creazione cartella fallita"
#define MSGDIRECT_FOLDERSUCCESS          "Cartella %s creata correttamente"
#define MSGDIRECT_FOLDERNOTFOUND         "ERR: cartella %s non trovata"
#define MSGDIRECT_FOLDERNOTEMPTY         "ERR: impossibile canc. cartella non vuota"
#define MSGDIRECT_CANNOTDELETEMAIN       "ERR: impossibile cancellare cartella main"
#define MSGDIRECT_REQUEST                "Richiesta"
#define MSGDIRECT_SURETODELETEFOLDER     "Cancellare la cartella attiva?"
#define MSGDIRECT_SUCCESSDELFOLDER       "Cartella %s cancellata"
#define MSGDIRECT_FAILEDDELFOLDER        "Cancellazione cartella %s fallita"
#define MSGDIRECT_SUREDELACTIVE          "Cancellare file attivo?"
#define MSGDIRECT_SUREDELMARKED          "Cancellare file selezionati?"
#define MSGDIRECT_FAILEDDELFILE          "ERR: cancellazione di %s fallita"
#define MSGDIRECT_SUCESSDELFILE          "file %s cancellato"
#define MSGDIRECT_SUCESSDELONEFILE       "1 file cancellato"
#define MSGDIRECT_SUCESSDELMULTIFILE     "%d file cancallati"
#define MSGDIRECT_FILENAMEEXISTS         "ERR: %s esiste gi"
#define MSGDIRECT_CANNOTOPENFILE         "ERR: impossibile aprire %s"
#define MSGDIRECT_CANNOTCREATEFILE       "ERR: impossibile creare %s"
#define MSGDIRECT_SELECTDESTINATION      "Cartella di destinazione"
#define MSGDIRECT_COPYTO                 "Copiare in:"
#define MSGDIRECT_MOVETO                 "Spostare in:"
#define MSGDIRECT_COPYMSGPOSTFIX         "copiato"
#define MSGDIRECT_MOVEMSGPOSTFIX         "spostato"
#define MSGDIRECT_FILE_POSTFIX_TO_FILE   "%s %s in %s"
#define MSGDIRECT_ONEFILE_POSTFIX        "1 file %s"
#define MSGDIRECT_MULTIFILE_POSTFIX      "%d file %s"
#define MSGDIRECT_FAILEDMOVEFILE         "ERR: impossibile spostare %s in %s"
#define MSGDIRECT_ENTERNEWFILENAME       "Immettrere nuovo nome file"
#define MSGDIRECT_CANNOTRENAMEMAIN       "ERR: impossibile rinominare cartella main"
#define MSGDIRECT_ENTERNEWFOLDERNAME     "Immettrere nuovo nome cartella"
#define MSGDIRECT_NEWNAME                "Nuovo nome:"
#define MSGDIRECT_INVALIDFILENAME        "ERR: nome file non valido"
#define MSGDIRECT_INVALIDFOLDERNAME      "ERR: nome cartella non valido"
#define MSGDIRECT_FAILEDRENAME           "ERR: impossibile rinominare %s in %s"
#define MSGDIRECT_SUCCESSRENAME          "%s renominato in %s"
#define MSGDIRECT_SYSTEMFILE             "ERR: file sistema"

#elif defined(LANGUAGE_portuguese) || defined(LANGUAGE_PORTUGUESE)
#define MSGDIRECT_PLEASESELECT           "Por favor selecione um arquivo"
#define MSGDIRECT_PROCESSARCHIVE         "(Des-)Arquivando ..."
#define MSGDIRECT_PROCESSLOCKING         "(Des-)bloqueando ..."
#define MSGDIRECT_CURRENTINUSE           "ERR: %s esta em uso"
#define MSGDIRECT_LOCKEDORARCHIVED       "ERR: arquivo %s esta bloq. ou arqui."
#define MSGDIRECT_UNARCHIVEFAILED        "ERR: desarquivacao falhou"
#define MSGDIRECT_ARCHIVEFAILED          "ERR: arquivacao ok"
#define MSGDIRECT_NOFILEPROCESSED        "Nenhum arquivo processado"
#define MSGDIRECT_ONEFILEPROCESSED       "1 arquivo processado"
#define MSGDIRECT_MULTIFILEPROCESSED     "%d arquivos processados"
#define MSGDIRECT_ENTERFOLDERTOCREATE    "Entre o Nome da Pasta a Criar"
#define MSGDIRECT_FOLDERNAME             "Nome da Pasta:"
#define MSGDIRECT_STARTWITHLETTER        "ERR: pastas precisao comecar com letra"
#define MSGDIRECT_FOLDEREXISTS           "ERR: pasta ja existe"
#define MSGDIRECT_FOLDERCREATIONFAILED   "ERR: criacao de pasta falhou"
#define MSGDIRECT_FOLDERSUCCESS          "Pasta %s criada corretamente"
#define MSGDIRECT_FOLDERNOTFOUND         "ERR: pasta %s nao pode ser encontrada"
#define MSGDIRECT_FOLDERNOTEMPTY         "ERR: pasta cheia nao pode ser deletada"
#define MSGDIRECT_CANNOTDELETEMAIN       "ERR: pasta main nao pode ser deletada"
#define MSGDIRECT_REQUEST                "Pedido"
#define MSGDIRECT_SURETODELETEFOLDER     "Deletar Pasta Ativa?"
#define MSGDIRECT_SUCCESSDELFOLDER       "pasta %s deletada"
#define MSGDIRECT_FAILEDDELFOLDER        "delecao da pasta %s falhou"
#define MSGDIRECT_SUREDELACTIVE          "Deletar arquivo Ativo?"
#define MSGDIRECT_SUREDELMARKED          "Deletar Arquivos Marcados?"
#define MSGDIRECT_FAILEDDELFILE          "ERR: delecao de %s falhou"
#define MSGDIRECT_SUCESSDELFILE          "arquivo %s deletado"
#define MSGDIRECT_SUCESSDELONEFILE       "1 arquivo deletado"
#define MSGDIRECT_SUCESSDELMULTIFILE     "%d arquivos deletados"
#define MSGDIRECT_FILENAMEEXISTS         "ERR: %s ja existe"
#define MSGDIRECT_CANNOTOPENFILE         "ERR: %s nao pode ser aberto"
#define MSGDIRECT_CANNOTCREATEFILE       "ERR: %s nao pode ser criado"
#define MSGDIRECT_SELECTDESTINATION      "Selecione a Pasta de Destino"
#define MSGDIRECT_COPYTO                 "Copiar para:"
#define MSGDIRECT_MOVETO                 "Mover para:"
#define MSGDIRECT_COPYMSGPOSTFIX         "copiado"
#define MSGDIRECT_MOVEMSGPOSTFIX         "movido"
#define MSGDIRECT_FILE_POSTFIX_TO_FILE   "%s %s para %s"
#define MSGDIRECT_ONEFILE_POSTFIX        "1 arquivo %s"
#define MSGDIRECT_MULTIFILE_POSTFIX      "%d arquivos %s"
#define MSGDIRECT_FAILEDMOVEFILE         "ERR: movendo %s para %s falhou"
#define MSGDIRECT_ENTERNEWFILENAME       "Entre o Novo Nome do Arquivo"
#define MSGDIRECT_CANNOTRENAMEMAIN       "ERR: pasta main nao pode ser renomeada"
#define MSGDIRECT_ENTERNEWFOLDERNAME     "Entre o Novo Nome da Pasta"
#define MSGDIRECT_NEWNAME                "Novo Nome:"
#define MSGDIRECT_INVALIDFILENAME        "ERR: nome de arquivo invalido"
#define MSGDIRECT_INVALIDFOLDERNAME      "ERR: nome de pasta invalida"
#define MSGDIRECT_FAILEDRENAME           "ERR: renomeando %s para %s falhou"
#define MSGDIRECT_SUCCESSRENAME          "%s renomeado para %s"
#define MSGDIRECT_SYSTEMFILE             "ERR: fichier systeme"

#else
#error no language defined !!!
#endif


#include <tigcclib.h>
//#define MSGS_EXPLORER
//#include "messages.h"
#include "common.h"
#include "file.h"
#include "vatutils.h"
#include "menu.h"
#include "font5x5.h"

extern file_t* file_list;
extern folder_t* folder_list;
extern short file_count;
extern short folder_count;
extern short active_folder;
extern short global_mode;
extern short active_file;

extern void DrawStatusLine(const char* msg);
extern unsigned short GetUserInput(void);

//-----------------------------------------------------------------------------
// value used to set a file to state MARKED
//-----------------------------------------------------------------------------
#define FILE_MARKED      1


/*===========================================================================*/
/* handles archiving/unarchiving or locking/unlocking of files               */
/* returns count of changed files                                            */
/*                                                                           */
/* NOTE:  a popup about garbage collection may be thrown by the AMS          */
/* NOTE2: may change the font due to the popup                               */
/* NOTE3: (un)-locking operation is skipped if file is archived (it will     */
/*        stay locked)                                                       */
/*                                                                           */
/* We have to be very careful about LOCKED or TWIN symbols                   */
/*===========================================================================*/
short HandleArchiveOrLock(char* msg,short operation) {
    short      i;
    char       tname[30];
    char*      tiosname;
    short      change_count = 0;
    short      single       = 1;

    msg[0] = 0;

    file_t *f = &file_list[0];

    for (i=0;i<file_count;i++) {
        if (f->marked == FILE_MARKED) {
//        if (file_list[i].marked == FILE_MARKED) {
            single = 0;
            break;
        }
        f++;
    }

    if (global_mode==SCROLL_FOLDER && single) {
        strcpy(msg,MSGDIRECT_PLEASESELECT);
        return 0;
    }

    if (operation == OPERATION_ARCHIVE) DrawStatusLine(MSGDIRECT_PROCESSARCHIVE);
    else                                DrawStatusLine(MSGDIRECT_PROCESSLOCKING);

    f = &file_list[0];
    for (i=0;i<file_count;i++) {
        // Smaller than the other construct...
        if ((single && i == active_file && !(f->flags.bits.hidden)) ||
            (f->marked == FILE_MARKED && !(f->flags.bits.hidden)))
/*
        if ((single && i == active_file && !((f->flags.flags_n)&SF_HIDDEN)) ||
            (f->marked == FILE_MARKED && !((f->flags.flags_n)&SF_HIDDEN)))
*/
        {
            tiosname = GenerateTIOSName(f->name,tname);

            //-------------------------------------------------------------
            // it's important to make sure that this file is not in use
            //-------------------------------------------------------------
            if (IsInUse(tiosname)) {
                sprintf(msg,MSGDIRECT_CURRENTINUSE,f->name);
                return change_count;
            }
            //HeapCompress(); // compress heap first !!!
            //EM_GC(FALSE);   // garbage collect archive

            //-------------------------------------------------------------
            // it's important to make sure that this file is not a system
            // file
            //-------------------------------------------------------------
            if (   /*CheckReservedName(tiosname))
            ||*/ SymSysVar(f->name)) {
                sprintf(msg,MSGDIRECT_SYSTEMFILE);
                return change_count;
            }

            //-----------------------------------------------------------------
            // handle (un)archiving ...
            //-----------------------------------------------------------------
            if (operation == OPERATION_ARCHIVE) {
                // Smaller than the other construct.
                if (f->flags.bits.archived) {
//                if ((f->flags.flags_n)&SF_ARCHIVED) {
                    if (!EM_moveSymFromExtMem(tiosname, HS_NULL)) {
                        strcpy(msg,MSGDIRECT_UNARCHIVEFAILED);
                        return change_count;
                    }
                }
                else {
                    if (!EM_moveSymToExtMem(tiosname, HS_NULL)) {
                        strcpy(msg,MSGDIRECT_ARCHIVEFAILED);
                        return change_count;
                    }
                }
            }
            //-----------------------------------------------------------------
            // handle (un)locking ...
            //-----------------------------------------------------------------
            else {
                 SYM_ENTRY* symptr = GetSymByName(tiosname);

                 if ((symptr) && (!((symptr->flags.flags_n)&SF_ARCHIVED))) {
                     (symptr->flags.flags_n) ^= SF_LOCKED;
                 }

/*
                 if (symptr && !symptr->flags.bits.archived) {
                     symptr->flags.bits.locked = !(symptr->flags.bits.locked);
                 }
*/
            }

            change_count++;
            f->marked = !FILE_MARKED;

            if (single) return change_count;
        }
        f++;
    }

    if (!msg[0]) {
        if (!change_count) strcpy(msg,MSGDIRECT_NOFILEPROCESSED);
        else if (change_count == 1) strcpy(msg,MSGDIRECT_ONEFILEPROCESSED);
        else                        sprintf(msg,MSGDIRECT_MULTIFILEPROCESSED,change_count);
    }

    return change_count;
}


/*===========================================================================*/
/* handles creation of a folder                                              */
/* returns 1 if folder was created successfully                              */
/*===========================================================================*/
short HandleCreateFolder(char* msg) {
    char  buffer[9];
    char  tname[30];
    char* tiosname;

    DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_ENTERFOLDERTOCREATE);
    FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_FOLDERNAME);

    // check if user pressed ESCAPE or entered nothing
    if (!DrawAndHandleInputField(OFFSET_X+79,OFFSET_Y+40,buffer)) {
        msg[0] = 0;
        return 0;
    }

    // check if user entered a valid name (such names are that of temporary folders)
    if (buffer[0] >= '0' && buffer[0] <= '9') {
        strcpy(msg,MSGDIRECT_STARTWITHLETTER);
        return 0;
    }

    tiosname = GenerateTIOSName(buffer,tname);

    if (SymFindHome(tiosname).folder) {
        strcpy(msg,MSGDIRECT_FOLDEREXISTS);
        return 0;
    }

    if (!FolderAdd(tiosname)) {
        strcpy(msg,MSGDIRECT_FOLDERCREATIONFAILED);
        return 0;
    }

    sprintf(msg,MSGDIRECT_FOLDERSUCCESS,buffer);
    return 1;
}


/*===========================================================================*/
/* handles delete files                                                      */
/* returns 0 if no refresh is necessary                                      */
/*===========================================================================*/
short HandleDeleteFiles(char* msg) {
    char  tname[50];
    short del_active = 0;
    short del_count  = 0;
    short i;

    //-------------------------------------------------------------------------
    // treat deletion of folder
    //-------------------------------------------------------------------------
    if (global_mode == SCROLL_FOLDER) {
        short number;
        HSym hs;
        char* tiosname = GenerateTIOSName(folder_list[active_folder].name,tname);
        hs = SymFindHome(tiosname);
        if (!hs.folder) {
            sprintf(msg,MSGDIRECT_FOLDERNOTFOUND,folder_list[active_folder].name);
            return 0;
        }

        if (IsMainFolderStr(folder_list[active_folder].name)) {
//        if (!strcmp(folder_list[active_folder].name,"main")) {
            strcpy(msg,MSGDIRECT_CANNOTDELETEMAIN);
            return 0;
        }

        number = FolderCount(DerefSym(hs));

        if (number) {
            strcpy(msg,MSGDIRECT_FOLDERNOTEMPTY);
            return 0;
        }

        DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_REQUEST);
        FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_SURETODELETEFOLDER);

        if (GetUserInput() != KEY_ENTER) return 0;

        if (FolderDel(tiosname)) {
            sprintf(msg,MSGDIRECT_SUCCESSDELFOLDER,folder_list[active_folder].name);
            if (active_folder < folder_count-2) active_folder++;
            else if (active_folder > 1)         active_folder--;
            return 1;
        }
        else {
            sprintf(msg,MSGDIRECT_FAILEDDELFOLDER,folder_list[active_folder].name);
            return 0;
        }
    }


    //-------------------------------------------------------------------------
    // if we come here we should delete files ...
    //-------------------------------------------------------------------------

    // count files to delete ...
    file_t *f = &file_list[0];
    for (i=0;i<file_count;i++) {
        if (f->marked == FILE_MARKED) del_count++;
//        if (file_list[i].marked == FILE_MARKED) del_count++;
        f++;
    }

    if (!del_count) {
        char* act_name = file_list[active_file].name;
        if (IsInUse(act_name)) {
            sprintf(msg,MSGDIRECT_CURRENTINUSE,act_name);
            return 0;
        }
        //-------------------------------------------------------------
        // it's important to make sure that this file is not a system
        // file
        //-------------------------------------------------------------
        if (   /*CheckReservedName(GenerateTIOSName(act_name,tname))
            ||*/ SymSysVar(act_name)) {
            sprintf(msg,MSGDIRECT_SYSTEMFILE);
            return 0;
        }
        // TODO: support deletion of archived files.
        else if (file_list[active_file].flags.bits.archived ||
                 file_list[active_file].flags.bits.locked)
        {
            sprintf(msg,MSGDIRECT_LOCKEDORARCHIVED,act_name);
            return 0;
        }
        else {
            del_active = 1;
        }
    }

    DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_REQUEST);


    if (del_active) FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_SUREDELACTIVE);
    else            FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_SUREDELMARKED);

    if (GetUserInput() != KEY_ENTER) return 0;

    del_count = 0;
    f = &file_list[0];
    for (i=0;i<file_count;i++) {
        if (f->marked == FILE_MARKED ||
            (del_active && i == active_file))
        {
            char* act_name = f->name;
            char s[50];
            sprintf(s,"%s\\%s",folder_list[active_folder].name,act_name);
           // TODO: support deletion of archived files.
            if (((f->flags.flags_n)&SF_LOCKED) || ((f->flags.flags_n)&SF_ARCHIVED)) {
//            if (file_list[i].flags.bits.locked || file_list[i].flags.bits.archived) {
                sprintf(msg,MSGDIRECT_LOCKEDORARCHIVED,act_name);
                return 1;
            }
            else if (IsInUse(s)) {
                sprintf(msg,MSGDIRECT_CURRENTINUSE,act_name);
                return 1;
            }

            //-------------------------------------------------------------
            // it's important to make sure that this file is not a system
            // file
            //-------------------------------------------------------------
            if ( /* CheckReservedName(GenerateTIOSName(s,tname))
                || */SymSysVar(act_name)) {
                sprintf(msg,MSGDIRECT_SYSTEMFILE);
                return 0;
            }

            if (!SymDel(GenerateTIOSName(s,tname))) {
                sprintf(msg,MSGDIRECT_FAILEDDELFILE,act_name);
                return 1;
            }
            del_count++;

            if (del_active) {
                sprintf(msg,MSGDIRECT_SUCESSDELFILE,act_name);
                if (active_file < file_count-2) active_file++;
                else if (active_file > 1)       active_file--;
                return 1;
            }
        }
        f++;
    }

    if (del_count==1) {
        strcpy(msg,MSGDIRECT_SUCESSDELONEFILE);
    }
    else {
        sprintf(msg,MSGDIRECT_SUCESSDELMULTIFILE,del_count);
    }
    return 1;
}


/*===========================================================================*/
/* handles copying of one file                                               */
/* returns 1 if everything went okay                                         */
/*===========================================================================*/
static inline short CopyOneFile(char* msg,char* srcfolder,char* srcname,char* destfolder) {
    char           source[50];
    char           destination[50];
    char           tname[50];
    SYM_ENTRY*     symptr;
    unsigned char* sbuf;
    unsigned char* dbuf;
    unsigned short len;
    HANDLE         sh;
    HANDLE         dh;
    HSym           hsym;

    //-------------------------------------------------------------
    // it's important to make sure that this file is not a system
    // file
    //-------------------------------------------------------------
    if (/* CheckReservedName(GenerateTIOSName(srcname,tname))
        || */SymSysVar(srcname)) {
        sprintf(msg,MSGDIRECT_SYSTEMFILE);
        return 0;
    }

    sprintf(source,"%s\\%s",srcfolder,srcname);

    if (!(symptr=GetSymByName(source)) || !symptr->handle) {
        sprintf(msg,MSGDIRECT_CANNOTOPENFILE,source);
        return 0;
    }

    if (IsInUse(source)) {
        sprintf(msg,MSGDIRECT_CURRENTINUSE,source);
        return 0;
    }

    // Copy to same folder ?
    if (!(strcmp(srcfolder,destfolder))) {
        if (strlen(srcname)<=5) {
            strcpy(tname,"cpy");
            strcat(tname,srcname);
            srcname = tname;
        }
        else {
            *(srcname+0) = 'c';
            *(srcname+1) = 'p';
            *(srcname+2) = 'y';
        }
    }

    sprintf(destination,"%s\\%s",destfolder,srcname);
    if (GetSymByName(destination)) {
        sprintf(msg,MSGDIRECT_FILENAMEEXISTS,destination);
        return 0;
    }

    sh   = symptr->handle;
    sbuf = SaveHeapLock(sh);
    len  = *(unsigned short*)(sbuf) + 2;

    if (!(dh = HeapAlloc(len))) {
        strcpy(msg,GetMsg(MSG_ERR_OUTOFMEM));
        SaveHeapUnLock();
        return 0;
    }

    dbuf = HLock(dh);
    memcpy(dbuf,sbuf,len);
    SaveHeapUnLock();
    HeapUnlock(dh);

    hsym = SymAdd(GenerateTIOSName(destination,tname));
    if (!hsym.folder || !(symptr = DerefSym(hsym))) {
        sprintf(msg,MSGDIRECT_CANNOTCREATEFILE,destination);
        HeapFree(dh);
        return 0;
    }

    symptr->handle = dh;
    return 1;
}


extern SCR_RECT fullscreen;
/*===========================================================================*/
/* draws and handles a folder selection field                                */
/* returns -1 or index in list                                               */
/*===========================================================================*/
static inline short DrawAndHandleFolderSelectField(short x,short y) {
    short    count = 0;
    unsigned short input;
    short    redraw = 1;
/*
    WIN_RECT w     = {x,y,x+8*6+2,y+8};
    SCR_RECT s     = {{w.x0+1,w.y0+1,w.x1-1,w.y1-1}};
*/

// New smaller construct.
    WIN_RECT w;
    SCR_RECT s;

    w.x0 = x;
    s.xy.x0 = x+1;

    w.y0 = y;
    s.xy.y0 = y+1;

    s.xy.x1 = x+8*6+1;
    w.x1 = x+8*6+2;

    s.xy.y1 = y+7;
    w.y1 = y+8;


    DrawClipRect(&w,&fullscreen,A_NORMAL);
    ScrRectFill(&s,&fullscreen,A_NORMAL);

    do {
        if (redraw) {
            ScrRectFill(&s,&fullscreen,A_NORMAL);
            DrawStr(x+1,y+2,folder_list[count].name,A_REVERSE);
            redraw = 0;
        }

        input = tolower(GetUserInput());
        if (input == KEY_ESC)        return -1;
        else if (input == KEY_ENTER) return count;
        else if (input == KEY_DOWN || input == C89_92(344,340) /*KEY_RIGHT*/) {
            count++;
            if (count >= folder_count) count=0;
            redraw++;
        }
        else if (input == KEY_UP || input == KEY_LEFT) {
            count--;
            if (count<0) count = folder_count-1;
            redraw++;
        }
    }
    while (1);
}


/*===========================================================================*/
/* handles copying of files                                                  */
/*===========================================================================*/
short HandleCopyOrMoveFiles(char* msg,short operation) {
    short process_count  = 0;
    short process_active = 1;
    short i;
    short dest_index;
    const char* postfix;
    char* act_name;

    file_t *f = &file_list[0];
    for (i=0;i<file_count;i++) {
        if (f->marked == FILE_MARKED) {
            process_active = 0;
            break;
        }
        f++;
    }

    if (process_active) {
        if (global_mode == SCROLL_FOLDER) {
            strcpy(msg,MSGDIRECT_PLEASESELECT);
            return 0;
        }

        act_name = file_list[active_file].name;
        if (IsInUse(act_name)) {
            sprintf(msg,MSGDIRECT_CURRENTINUSE,act_name);
            return 0;
        }
        else if (operation == OPERATION_MOVE) {
            if (IsHeapLocked(act_name) || file_list[active_file].flags.bits.locked)
            {
                sprintf(msg,MSGDIRECT_LOCKEDORARCHIVED,act_name);
                return 0;
            }
        }
    }

    DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_SELECTDESTINATION);
    if (operation == OPERATION_COPY) {
        FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_COPYTO);
        postfix = MSGDIRECT_COPYMSGPOSTFIX;
    }
    else {
        FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_MOVETO);
        postfix = MSGDIRECT_MOVEMSGPOSTFIX;
    }
    dest_index = DrawAndHandleFolderSelectField(OFFSET_X+79,OFFSET_Y+40);

    if (dest_index == -1 /*|| dest_index == active_folder*/) {
        return 0;
    }

    process_count=0;
    f = &file_list[0];
    for (i=0;i<file_count;i++) {
        if (f->marked == FILE_MARKED ||
            (process_active && i == active_file))
        {
            act_name = file_list[i].name;
            if (operation == OPERATION_COPY) {
                if (!CopyOneFile(msg,folder_list[active_folder].name,
                                 act_name,
                                 folder_list[dest_index].name))
                {
                    return 1;
                }
            }
            else {
                char source[50];
                char destination[50];
                char stios[50];
                char dtios[50];

                sprintf(source,"%s\\%s",folder_list[active_folder].name,act_name);
                sprintf(destination,"%s\\%s",folder_list[dest_index].name,act_name);
                if (IsHeapLocked(source)      ||
                    (f->flags.bits.locked)    ||
//                    ((f->flags.flags_n)&SF_LOCKED)   ||
                    IsInUse(source)           ||
                    GetSymByName(destination))
                {
                    sprintf(msg,MSGDIRECT_FAILEDMOVEFILE,act_name,folder_list[dest_index].name);
                    return 1;
                }
                //-------------------------------------------------------------
                // it's important to make sure that this file is not a system
                // file
                //-------------------------------------------------------------
                if (/* CheckReservedName(GenerateTIOSName(srcname,tname))
                    || */SymSysVar(act_name)) {
                    sprintf(msg,MSGDIRECT_SYSTEMFILE);
                    return 0;
                }
                if (!SymMove(GenerateTIOSName(source,stios),
                             GenerateTIOSName(destination,dtios)))
                {
                    sprintf(msg,MSGDIRECT_FAILEDMOVEFILE,act_name,folder_list[dest_index].name);
                    return 1;
                }

                if (process_active) {
                    if (active_file < file_count-2) active_file++;
                    else if (active_file > 1)       active_file--;
                }
            }
            process_count++;
            if (process_active) {
                sprintf(msg,MSGDIRECT_FILE_POSTFIX_TO_FILE,act_name,postfix,folder_list[dest_index].name);
                return 1;
            }
        }
        f++;
    }

    if (process_count == 1) {
        sprintf(msg,MSGDIRECT_ONEFILE_POSTFIX,postfix);
    }
    else {
        sprintf(msg,MSGDIRECT_MULTIFILE_POSTFIX,process_count,postfix);
    }
    return 1;
}


/*===========================================================================*/
/* handles renaming of a file                                                */
/*===========================================================================*/
short HandleRenameFile(char* msg) {
    char   source[50];
    char   destination[50];
    char   stios[50];
    char   dtios[50];
    char   buffer[9];
    char*  act_name;

    if (global_mode == SCROLL_FILE) {
        act_name = file_list[active_file].name;
        if (IsInUse(act_name)) {
            sprintf(msg,MSGDIRECT_CURRENTINUSE,act_name);
            return 0;
        }
        else if (IsHeapLocked(act_name) || file_list[active_file].flags.bits.locked) {
            sprintf(msg,MSGDIRECT_LOCKEDORARCHIVED,act_name);
            return 0;
        }
        DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_ENTERNEWFILENAME);
    }
    else {
        act_name = folder_list[active_folder].name;
        if (IsMainFolderStr(act_name)) {
//        if (!strcmp(act_name,"main")) {
            strcpy(msg,MSGDIRECT_CANNOTRENAMEMAIN);
            return 0;
        }
        DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_ENTERNEWFOLDERNAME);
    }

    FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_NEWNAME);

    if (!DrawAndHandleInputField(OFFSET_X+79,OFFSET_Y+40,buffer)) {
        return 0;
    }

    // check if user has entered a valid name (doesn't start with a number)
    if (buffer[0] >= '0' && buffer[0] <= '9') {
        if (global_mode == SCROLL_FILE) strcpy(msg,MSGDIRECT_INVALIDFILENAME);
        else                            strcpy(msg,MSGDIRECT_INVALIDFOLDERNAME);
        return 0;
    }

    if (global_mode == SCROLL_FILE) {
        if (GetSymByName(buffer)) {
            sprintf(msg,MSGDIRECT_FILENAMEEXISTS,buffer);
            return 0;
        }

        sprintf(source,     "%s\\%s",folder_list[active_folder].name,act_name);
        sprintf(destination,"%s\\%s",folder_list[active_folder].name,buffer);

        //-------------------------------------------------------------
        // it's important to make sure that this file is not a system
        // file
        //-------------------------------------------------------------
        if (/* CheckReservedName(GenerateTIOSName(srcname,tname))
            || */SymSysVar(act_name)) {
            sprintf(msg,MSGDIRECT_SYSTEMFILE);
            return 0;
        }
        if (!SymMove(GenerateTIOSName(source,stios),
                     GenerateTIOSName(destination,dtios)))
        {
            sprintf(msg,MSGDIRECT_FAILEDRENAME,act_name,buffer);
            return 0;
        }
        sprintf(msg,MSGDIRECT_SUCCESSRENAME,act_name,buffer);
        strcpy(file_list[active_file].name,buffer);
    }
    else {
        char* dest = GenerateTIOSName(buffer,dtios);

        if (SymFindHome(GenerateTIOSName(buffer,dtios)).folder != H_NULL) {
            sprintf(msg,MSGDIRECT_FILENAMEEXISTS,buffer);
            return 0;
        }
        if (!FolderRename(GenerateTIOSName(act_name,stios),dest)) {
            sprintf(msg,MSGDIRECT_FAILEDRENAME,act_name,buffer);
            return 0;
        }
        sprintf(msg,MSGDIRECT_SUCCESSRENAME,act_name,buffer);
        strcpy(folder_list[active_folder].name,buffer);
    }

    return 1;
}


//=============================================================================
// Revision History
//=============================================================================
//
// $Log: file.c,v $
// Revision 1.12  2002/09/23 09:37:38  tnussb
// generic commit (see history.txt: changes up to v1.30 Beta 7)
//
// Revision 1.11  2002/09/10 11:28:41  tnussb
// changes up to v1.30 Beta 4 / examine history.txt for details
//
// Revision 1.10  2002/02/07 18:01:17  tnussb
// generic commit
//
// Revision 1.9  2001/02/04 13:11:27  Thomas Nussbaumer
// changes up to version 1.00 RC2 (see history.txt)
//
// Revision 1.8  2001/01/26 21:04:44  Thomas Nussbaumer
// changes for version 0.80 [see history.txt]
//
// Revision 1.7  2001/01/21 00:20:16  Thomas Nussbaumer
// additionally changes related to version 0.60
//
// Revision 1.6  2001/01/17 23:38:41  Thomas Nussbaumer
// changes related to version 0.50 (see history.txt)
//
// Revision 1.5  2001/01/16 03:42:25  Thomas Nussbaumer
// see history.txt (up to version 0.40)
//
// Revision 1.4  2001/01/15 00:08:19  Thomas Nussbaumer
// see history.txt (up to v0.34) for what's new
//
// Revision 1.3  2001/01/06 23:15:29  Thomas Nussbaumer
// see history.txt file for changes (new in v0.27 till v0.29)
//
// Revision 1.2  2001/01/03 19:32:40  Thomas Nussbaumer
// see history.txt file for changes (new in v0.25 and v0.26)
//
// Revision 1.1  2001/01/02 16:30:43  Thomas Nussbaumer
// initial version
//
//
//
