/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     font5x5.c
* initial date:  31/12/2000
* author:        thomas.nussbaumer@gmx.net
*
* description:   font 4x6 drawing routine
*
* $Id: font5x5.c,v 1.8 2002/09/23 09:37:38 tnussb Exp $
*
******************************************************************************/

#include <tigcclib.h>
#include "font5x5.h"

extern unsigned char* __F_4x6_Font__;


//=============================================================================
// returns width of string
//=============================================================================
unsigned short __attribute__((__regparm__)) FastStringWidth(const unsigned char* s) {
    short width = 0;
    while (*s) {
        width += *(unsigned char*)&(__F_4x6_Font__[(short)(*s++)*6]);
    }
    return width;
}


asm("
.text
.xdef masks
masks:
.byte 0xFF
.byte 0x7F
.byte 0x3F
.byte 0x1F
.byte 0x0F
.byte 0x07
.byte 0x03
.byte 0x01
.byte 0x00
.even
");


//=============================================================================
// draws string using own sprites (about 4 times faster than DrawStrXY)
//=============================================================================
void FastStringXY(register short x asm("%d0"),
                  register short y asm("%d1"),
                  register const unsigned char* s asm("%a0"));
asm("
.text
    .global FastStringXY
FastStringXY:
    movem.l  %d3-%d5/%a2-%a5,-(%sp)

    add.w    %d1,%d1
    move.w   %d1,%d2
    lsl.w    #4,%d2
    sub.w    %d1,%d2
    move.l   used_lcdbuffer(%pc),%a1
    adda.w   %d2,%a1

    move.l   __F_4x6_Font__(%pc),%a2
    lea      masks(%pc),%a5

0:
    moveq    #0,%d2
    move.b   (%a0)+,%d2
    jbeq     2f

    add.w    %d2,%d2
    move.w   %d2,%d1
    add.w    %d2,%d2
    add.w    %d1,%d2
    lea      0(%a2,%d2.w),%a4

    move.w   %d0,%d1
    lsr.w    #4,%d1
    add.w    %d1,%d1
    lea      0(%a1,%d1.w),%a3

    moveq    #0,%d5
    move.b   (%a4)+,%d5

    move.w   %d0,%d1
    andi.w   #0xF,%d1

    moveq    #24,%d2
    sub.w    %d1,%d2
    moveq    #5-1,%d1

1:
    moveq    #0,%d3
    moveq    #-1,%d4
    move.b   (%a4)+,%d3
    move.b   0(%a5,%d5.w),%d4
    lsl.l    %d2,%d3
    rol.l    %d2,%d4
    and.l    %d4,(%a3)
    or.l     %d3,(%a3)
    lea      30(%a3),%a3

    dbf      %d1,1b

    add.w    %d5,%d0

    bra.s    0b


2:
    movem.l  (%sp)+,%d3-%d5/%a2-%a5
    rts
");


//=============================================================================
// initializes everything necessary for fast string drawing
// The new implementation which takes up no additional memory was made by
// Lionel Debroux.
//=============================================================================
extern short InitializeFastString(void);
asm (
".text\n"\
".xdef __F_4x6_Font__\n"\
".even\n"\
"__F_4x6_Font__:\n"\
".long 0\n"\
/*
".xdef __F_6x8_Font__\n"\
".even\n"\
"__F_6x8_Font__:\n"\
*/
".long 0\n"\
".xdef InitializeFastString\n"\
"InitializeFastString:\n"\
"    movem.l %d3/%a2,-(%sp)\n"\
"    movea.l 0xC8.w,%a2\n"\
"    cmpi.w #1000,-2(%a2)\n"\
"    bgt.s 2f\n"\
"    movea.l 0x1A9*4(%a2),%a0\n"\
"    cmpi.l #0x50656472,-(%a0) | 'Pedr', a signature of PedroM.\n"\
"    bne.s 1f\n"\
"    lea __F_4x6_Font__(%pc),%a1\n"\
"    move.l -12(%a0),(%a1)\n"\
"|    move.l -8(%a0),(%a1)\n"\
/*
"    lea __F_6x8_Font__(%pc),%a1\n"\
"    subq.l #4,%a0\n"\
"    move.l -(%a0),(%a1)\n"\
"    move.l -(%a0),-(%a1)\n"\
*/
"    bra.s 0f\n"\
"1:\n"\
"    lea 58+4(%a0),%a0 | Get rid of the cmpi.l #0x50656472,-(%a0) above.\n"\
"    movea.w (%a0),%a1\n"\
"    adda.l %a0,%a1\n"\
"    lea __F_4x6_Font__(%pc),%a0\n"\
"    move.l 122(%a1),(%a0)+\n"\
/*
"    move.l 106(%a1),(%a0)\n"\
*/
"    bra.s 0f\n"\
"2:\n"\
"    movea.l 0x45D*4(%a2),%a0 | EV_runningApp\n"\
"    move.w (%a0),%d3\n"\
"    beq.s 3f\n"\
"    movea.l 0x441*4(%a2),%a0  | HeapTable\n"\
"    lsl.w #2,%d3\n"\
"    movea.l 0(%a0,%d3.w),%a0\n"\
"    movea.l 20(%a0),%a0\n"\
"    bra.s 4f\n"\
"3:\n"\
"    lea 0xFF000000.l,%a0\n"\
"4:\n"\
"    movea.l 0x3FA*4(%a2),%a2 | OO_CondGetAttr\n"\
"    pea __F_4x6_Font__(%pc)\n"\
"    pea 0x300.w\n"\
"    pea (%a0)\n"\
"    jsr (%a2)\n"\
"    lea 12(%sp),%sp\n"\
"    tst.w %d0\n"\
"    beq.s 5f\n"\
/*
"    addq.l #4,8(%sp)\n"\
"    addq.w #1,6(%sp)\n"\
"    jsr (%a2)\n"\
"    tst.w %d0\n"\
"    beq.s 5f\n"\
*/
"0:\n"\
"    moveq #1,%d0\n"\
"6:\n"\
"    movem.l (%sp)+,%d3/%a2\n"\
"    rts\n"\
"5:\n"\
"    moveq #0,%d0\n"\
"    bra.s 6b");


//=============================================================================
// Revision History
//=============================================================================
//
// $Log: font5x5.c,v $
// Revision 1.8  2002/09/23 09:37:38  tnussb
// generic commit (see history.txt: changes up to v1.30 Beta 7)
//
// Revision 1.7  2002/03/15 15:07:13  tnussb
// uses now masking within FastDrawStringXY() (necessary for hex editor)
//
// Revision 1.6  2002/02/21 09:31:23  tnussb
// VERSION_TI89 and VERSION_TI92P replaced by new standard USE_TI89 and USE_TI92P
//
// Revision 1.5  2002/02/21 09:11:56  tnussb
// (1) FastStringXY replaced by faster version (not using Sprite8() anymore)
// (2) charset and charwidth not allocated separately anymore, but at once
//
// Revision 1.4  2002/02/07 18:01:17  tnussb
// generic commit
//
// Revision 1.3  2001/02/04 13:11:27  Thomas Nussbaumer
// changes up to version 1.00 RC2 (see history.txt)
//
//
