/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     hsr.c
* initial date:  04/09/2002
* author(s):     Greg Dietsche (original HSR 3.0 - 06/19/2002)
*                thomas.nussbaumer@gmx.net (minor modifications for TICT-Ex)
*                Lionel Debroux (modifications for TI-89T support)
*
* description:   Home Screen Restore (HSR)
*
* $Id: hsr.c,v 1.1 2002/09/10 11:28:04 tnussb Exp $
*
******************************************************************************/

asm(
".text\n"\
".xdef HomeScreenRestore\n"\
"HomeScreenRestore:\n"\
"     movem.l  %d0-%d7/%a0-%a6,-(%a7)\n"\
"     movea.l  0xC8,%a4\n"\
"     movea.l  (0x124,%a4),%a0\n"\
"     jsr      (%a0)               | call MenuUpdate\n"\
"     move.w   #0xA,-(%a7)\n"\
"     movea.l  (0x3AC,%a4),%a0\n"\
"     jsr      (%a0)               | call ST_refDsp with empty message\n"\
"     movea.l  (0x38C,%a4),%a0\n"\
"     jsr      (%a0)               | call ST_eraseHelp\n"\
"     pea      0x1E.w\n"\
"     move.w   #0xFFFF,-(%a7)\n"\
"     move.l   %a4,%d0\n"\
"     andi.l   #0xE00000,%d0\n"\
"     cmpi.l   #0x800000,%d0\n"\
"     beq.s    ____ti89            | TI-89T\n"\
"     cmpi.l   #0x400000,%d0\n"\
"     beq.s    ____ti92PV200       | TI-92P\n"\
"     cmpi.l   #0x200000,%d0\n"
"     bne.s    ____other_model     | unknown model, skip.\n"
"     movea.l  (0xBC,%a4),%a0\n"\
"     cmpi.b   #0xEF,(0x2,%a0)\n"\
"     beq.s    ____ti92PV200       | V200\n"\
"____ti89:\n"\
"| TI-89/TI-89T\n"\
"     pea      0x56E6.w\n"\
"     bra.s    ____drawline\n"\
"____ti92PV200:\n"\
"| TI-92P/V200\n"\
"     pea      0x5A2E.w\n"\
"____drawline:\n"\
"    movea.l  (0x9F0,%a4),%a0\n"\
"    jsr      (%a0)                | call memset (draws bottom line)\n"\
"____other_model:\n"\
"    movea.l  (%a4),%a0            | FirstWindow\n"\
"    movea.l  (%a0),%a0            | dereference the pointer\n"\
"____dirtywindows:\n"\
"    ori.w    #0x2000,(%a0)        | set Dirty Flag\n"\
"    tst.l    (0x22,%a0)           | is there another window?\n"\
"    movea.l  (0x22,%a0),%a0       | movea does not affect ccr\n"\
"    bne.s    ____dirtywindows\n"\
"    lea      (0xC,%a7),%a7\n"\
"    movem.l  (%a7)+,%d0-%d7/%a0-%a6\n"\
"    rts");

//=============================================================================
// Revision History
//=============================================================================
//
// $Log: hsr.c,v $
// Revision 1.1  2002/09/10 11:28:04  tnussb
// initial version
//
//
