/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     loadsave.h
* initial date:  26/09/2003
* authors:       thomas.nussbaumer@gmx.net
*                lionel_debroux@yahoo.fr
*
* description:   stuff related to the configuration file and the favorites
*
*
******************************************************************************/

#if !defined(TICTEX_LOADSAVE_H)
#define TICTEX_LOADSAVE_H

#include "interface.h"
//#define MSGS_EXPLORER
//#include "messages.h"
#include "common.h"
#include "vatutils.h"

// tictexco.nfig  ... name of configfile
#define CONFIG_FILENAME  "main\\tictexco"

#define CONFIG_EXTENSION "nfig"

#define CONFIG_MAGIC     C4L('E','X','P','L')
#define CONFIG_VERSION   C4L('1','.','0','0')

//-----------------------------------------------------------------------------
// NOTE: if this TICTEX_CONFIG structure changes, please change the define
//       CONFIG_VERSION define, too !!!
//-----------------------------------------------------------------------------
typedef struct {
     unsigned long  magic;
     unsigned long  version;
     char           favorites[18][9];
     unsigned char  types[9];      // types of favorites
     char           last_folder[9];
     char           last_file[9];
     unsigned short entry_used;
     unsigned short flags;         // misc. flags (16)
     unsigned char  pwd[9];        //default password
} TICTEX_CONFIG;

#define EMPTY_CONFIG_INIT {0,0,{{}},{},{},{},0,0,{}}
#define CONFIG_SIZE       (sizeof(TICTEX_CONFIG)+2+7)

extern TICTEX_CONFIG configuration;

#define FAVORITE_USED(_nr_)     (configuration.entry_used & (1 << (_nr_)))
#define SET_FAVORITE_USED(_nr_) (configuration.entry_used = configuration.entry_used | (1 << (_nr_)))
#define SET_FAVORITE_EMPTY(_nr_)(configuration.entry_used = configuration.entry_used & (~(1 << (_nr_))))

//extern void InitConfig(void);
extern short LoadConfig(void);
extern short SaveConfig(short hide_it);
extern void SetFavorite(char* msg, short nr,char* folder,char* file,char type);

extern short HandleSelectionPopup(short xpos,short ypos,const char* entries[],const char* shortcuts[]);
extern short HandleStart(file_t* data,char* folder);

/*
// WARNING!!! NOT REALLY CONSTANT -- WE WRITE INTO IT IN HandleFavoriteMenu() !!!
const char* favorite_entries[] = {
    "1:--------\\-------- ",
    "2:--------\\-------- ",
    "3:--------\\-------- ",
    "4:--------\\-------- ",
    "5:--------\\-------- ",
    "6:--------\\-------- ",
    "7:--------\\-------- ",
    "8:--------\\-------- ",
    "9:--------\\-------- ",
    MSGDIRECT_CLEARALLFAVORITES,NULL
};
const char* favorite_shorts[]= {
    "\x7F\x31",
    "\x7F\x32",
    "\x7F\x33",
    "\x7F\x34",
    "\x7F\x35",
    "\x7F\x36",
    "\x7F\x37",
    "\x7F\x38",
    "\x7F\x39",
    "",NULL
};
*/

extern short HandleFavoriteMenu(char* msg,short startone);

#endif

//=============================================================================
// Revision History
//=============================================================================
