/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     menu.c
* initial date:  03/01/2001
* authors:       thomas.nussbaumer@gmx.net (coding and main design)
*                Benjamin Canou aKa janjan2 (mods for TI92p/V200 fullscreen)
*
* description:   menu handling routines
*
* $Id: menu.c,v 1.13 2002/09/23 09:37:38 tnussb Exp $
*
******************************************************************************/

#include <tigcclib.h>

// TODO: improve the const char* arrays (trick used in tthdex, S1P6...) !

#if defined(LANGUAGE_deutsch) || defined(LANGUAGE_DEUTSCH)
const char* infopage[] = {
    "Aktiver Ordner",
    "Aktive Datei",
    "Handle/Adresse",
    "Typ",
    "Handles frei",
    "RAM frei",
    "Archiv benutzt",
    "Archiv frei",
    "Top of EStack",
    "RAM benutzt",
    "Batterie-Status"
};

const char *helppage[] = {
    "[2ND]+[UP]",       "Zur ersten Zeile",
    "[2ND]+[DOWN]",     "Zur letzten Zeile",
    "[2ND]+[NR]",       "Datei als Favorit NUMBER",
    "[\x7F]+[NUMBER]",  "Starte Favoriten NUMBER",
    "[a]-[z]",          "Quick Jump",
    "[BACKSPACE]",      "Loeschen"
};

const char* about[] = {
    "Eine TI-Chess Team Produktion",
    "von",
    "Thomas Nussbaumer",
    "und",
    "Marcos Lopez",
    "BESUCHE UNSERE WEBSITE",
    "http://tict.ticalc.org",
};

#define MSGDIRECT_HELPTITLE          "Hilfe"
#define MSGDIRECT_TESTPASSWORD       "Wie lautet das Passwort?"
#define MSGDIRECT_ENTERNEWPASSWORD   "Bitte neues Passwort eingeben"
#define MSGDIRECT_PASSWORD           "Passwort:"
#define MSGDIRECT_REENTERPASSWORD    "Bitte Passwort wiederholen"

#define MSGDIRECT_NUMFILES         "%s  [%d Datei(en)]"
#define MSGDIRECT_FILESIZE         "%s (%u Bytes)"
#define MSGDIRECT_FILELOCKED       "locked"
#define MSGDIRECT_FILEMOVABLE      "movable"
#define MSGDIRECT_MEMSIZE          "%lu Bytes"

#elif defined(LANGUAGE_spanish) || defined(LANGUAGE_SPANISH)
const char* infopage[] = {
    "Carpeta Activa",
    "Fichero Activo",
    "Handle/Direccion",
    "Tipo",
    "Handles libres",
    "RAM libre",
    "M Archivo usada",
    "M Archivo libre",
    "EStack llega hasta",
    "M RAM usada",
    "Estado de pilas"
};

const char* helppage[] = {
    "[2ND]+[ARRIBA]",       "Saltar a la primera linea",
    "[2ND]+[ABAJO]",     "Saltar a la ultima linea",
    "[2ND]+[NUM]",       "Fichero a Favorito NUM",
    "[\x7F]+[NUM]",  "Empezar Favorito NUM",
    "[a]-[z]",          "Salto directo",
    "[BORRAR]",      "Eliminar"
};

const char* about[] = {
    "Una produccion TI-Chess Team",
    "Por",
    "Thomas Nussbaumer",
    "Y",
    "Marcos Lopez",
    "VISITA NUESTRA PAGINA WEB EN",
    "http://tict.ticalc.org",
};

#define MSGDIRECT_HELPTITLE          "Pagina de ayuda"
#define MSGDIRECT_TESTPASSWORD       "Cual es el password?"
#define MSGDIRECT_ENTERNEWPASSWORD   "Introduce nuevo password"
#define MSGDIRECT_PASSWORD           "Password:"
#define MSGDIRECT_REENTERPASSWORD    "Reintroduce password"

#define MSGDIRECT_NUMFILES         "%s  [%d fich.]"
#define MSGDIRECT_FILESIZE         "%s (%u bytes)"
#define MSGDIRECT_FILELOCKED       "bloq."
#define MSGDIRECT_FILEMOVABLE      "movible"
#define MSGDIRECT_MEMSIZE          "%lu bytes"

#elif defined(LANGUAGE_french) || defined(LANGUAGE_FRENCH)
const char* infopage[] = {
    "Dossier actif",
    "Fichier actif",
    "Ident./Adresse",
    "Type",
    "Ident. libres",
    "Memoire libre",
    "Archive utilisee",
    "Archive libre",
    "Sommet pile exp.",
    "RAM utilisee",
    "Etat batteries"
};

const char *helppage[] = {
    "[2ND]+[HAUT]",     "Vers premiere ligne",
    "[2ND]+[BAS]",      "Vers derniere ligne",
    "[2ND]+[N]",        "Affecter prog. a favori N",
    "[\x7F]+[N]",       "Lancer favori N (N=1 a 9)",
    "[a]-[z]",          "Saut rapide",
    "[\x15]",           "Effacer"
};

const char* about[] = {
    "Une Production TI-Chess Team ",
    "Par",
    "Thomas Nussbaumer",
    "Et",
    "Marcos Lopez",
    "VISITEZ NOTRE SITE WEB A",
    "http://tict.ticalc.org",
};

#define MSGDIRECT_HELPTITLE          "Aide"
#define MSGDIRECT_TESTPASSWORD       "Entrez le mot de passe courant"
#define MSGDIRECT_ENTERNEWPASSWORD   "Entrez le nouveau mot de passe"
#define MSGDIRECT_PASSWORD           "Mot de passe:"
#define MSGDIRECT_REENTERPASSWORD    "Rentrez le mot de passe"

#define MSGDIRECT_NUMFILES           "%s  [%d fichier(s)]"
#define MSGDIRECT_FILESIZE           "%s (%u octets)"
#define MSGDIRECT_FILELOCKED         "verr."
#define MSGDIRECT_FILEMOVABLE        "mobile"
#define MSGDIRECT_MEMSIZE            "%lu octets"

#elif defined(LANGUAGE_english) || defined(LANGUAGE_ENGLISH)
const char* infopage[] = {
    "Active Folder",
    "Active File",
    "Handle/Address",
    "Type",
    "Handles free",
    "RAM free",
    "Archive used",
    "Archive free",
    "Top of EStack",
    "RAM used",
    "Battery State"
};

const char *helppage[] = {
    "[2ND]+[UP]",     "Jump to First Line",
    "[2ND]+[DOWN]",   "Jump to Last Line",
    "[2ND]+[NR]",     "File to Favorite NUMBER",
    "[\x7F]+[NUMBER]","Start Favorite NUMBER",
    "[a]-[z]",       "Quick Jump",
    "[BACKSPACE]",   "Delete"
};

const char* about[] = {
    "A TI-Chess Team Production",
    "By",
    "Thomas Nussbaumer",
    "And",
    "Marcos Lopez",
    "VISIT OUR WEBSITE AT",
    "http://tict.ticalc.org",
};

#define MSGDIRECT_HELPTITLE        "Help-Page"
#define MSGDIRECT_TESTPASSWORD     "Do you know the Password?"
#define MSGDIRECT_ENTERNEWPASSWORD "Please enter new Password"
#define MSGDIRECT_PASSWORD         "Password:"
#define MSGDIRECT_REENTERPASSWORD  "Please Re-Enter Password"

#define MSGDIRECT_NUMFILES         "%s  [%d file(s)]"
#define MSGDIRECT_FILESIZE         "%s (%u bytes)"
#define MSGDIRECT_FILELOCKED       "locked"
#define MSGDIRECT_FILEMOVABLE      "movable"
#define MSGDIRECT_MEMSIZE          "%lu bytes"

#elif defined(LANGUAGE_italian) || defined(LANGUAGE_ITALIAN)
const char* infopage[] = {
    "Cartella Attiva",
    "File Attivo",
    "Handle/Indirizzo",
    "Tipo",
    "Handle liberi",
    "RAM libera",
    "Archivio usato",
    "Archivio libero",
    "Inizio di EStack",
    "RAM usata",
    "Stato Batterie"
};

const char *helppage[] = {
    "[2ND]+[SU]",     "Salta alla Prima Linea",
    "[2ND]+[GIU']",      "Salta all'Ultima Linea",
    "[2ND]+[N.]",       "Aggiungi a Preferito N.",
    "[\x7F]+[N]",       "Lancia Preferito N. (1->9)",
    "[a]-[z]",          "Salto Rapido",
    "[<--]",           "Cancellare"
};

const char* about[] = {
    "Una Produzione TI-Chess Team ",
    "Di",
    "Thomas Nussbaumer",
    "E",
    "Marcos Lopez",
    "VISITATE IL NOSTRO SITO WEB",
    "http://tict.ticalc.org",
};

#define MSGDIRECT_HELPTITLE          "Aiuto"
#define MSGDIRECT_TESTPASSWORD       "Conosci la Password?"
#define MSGDIRECT_ENTERNEWPASSWORD   "Immettere nuova Password"
#define MSGDIRECT_PASSWORD           "Password:"
#define MSGDIRECT_REENTERPASSWORD    "Re-immettere la password"

#define MSGDIRECT_NUMFILES           "%s  [%d file]"
#define MSGDIRECT_FILESIZE           "%s (%u bytes)"
#define MSGDIRECT_FILELOCKED         "bloccato"
#define MSGDIRECT_FILEMOVABLE        "mobile"
#define MSGDIRECT_MEMSIZE            "%lu bytes"

#elif defined(LANGUAGE_portuguese) || defined(LANGUAGE_PORTUGUESE)
const char* infopage[] = {
    "Pasta Ativa",
    "Arquivo Ativo",
    "Handle/Endereco",
    "Tipo",
    "Handles livres",
    "RAM livre",
    "Arquivo usado",
    "Arquivo livre",
    "Topo do EStack",
    "RAM usada",
    "Estado das Baterias"
};

const char* helppage[] = {
    "[2ND]+[CIMA]", 	"Vai pra primeira linha",
    "[2ND]+[BAIXO]",    "Vai pra ultima linha",
    "[2ND]+[NUM]",      "Arq. para atalho NUMERO",
    "[\x7F]+[NUM]",  	"Executa Atalho NUMERO",
    "[a]-[z]",          "Pulo rapido",
    "[BACKSPACE]",     	"Deletar"
};

const char* about[] = {
    "Uma producao de TI-Chess Team",
    "Por",
    "Thomas Nussbaumer",
    "E",
    "Marcos Lopez",
    "Visite em:",
    "http://tict.ticalc.org",
};

#define MSGDIRECT_HELPTITLE          "Pagina de ajuda"
#define MSGDIRECT_TESTPASSWORD       "Voce sabe a Password?"
#define MSGDIRECT_ENTERNEWPASSWORD   "Entre a nova Password"
#define MSGDIRECT_PASSWORD           "Password:"
#define MSGDIRECT_REENTERPASSWORD    "Re-entre a password"

#define MSGDIRECT_NUMFILES         "%s  [%d arq.]"
#define MSGDIRECT_FILESIZE         "%s (%u bytes)"
#define MSGDIRECT_FILELOCKED       "bloq."
#define MSGDIRECT_FILEMOVABLE      "movivel"
#define MSGDIRECT_MEMSIZE          "%lu bytes"

#else
#error no language defined !!!
#endif


//#define MSGS_EXPLORER
//#include "messages.h"
#include "menu.h"

#include "interface.h"
#include "loadsave.h"
#include "vatutils.h"
#include "common.h"
#include "font5x5.h"
#include "battery.h"

extern SCR_RECT fullscreen;
extern file_t* file_list;
extern folder_t* folder_list;
extern short file_count;
extern short folder_count;
extern short active_folder;
extern short global_mode;
extern short active_file;

////extern void __ld_entry_point;
//extern char * __ld_entry_point;
//extern volatile TICTEX_INTERFACE* pti; // Dirty, but required for displaying memory consumption.

extern unsigned short GetUserInput(void);
extern void DrawStatusLine(const char* msg);
//extern unsigned short MapTI89Numbers(unsigned short input);
#define FillFullLines(y,nr,c)    memset((unsigned char*)LCD_MEM+(y)*30,c,30*(nr))

//#define INCLUDE_EASTER_EGG  // easter egg on info page if F3 is pressed

/*===========================================================================*/
/* draws a window (with or without titlebar) & background fade effect        */
/*===========================================================================*/
void DrawWindow(short x,short y,short width,short height,const char* title) {
// Inline assembly block: faster and smaller than the original C block:
/*
    short i,j;
    unsigned char sprite[]={0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55};
    for (j=0;j<C89_92(12,16);j++) {
        for (i=0;i<30;i++) {
            Sprite8(8*i,8*j,8,sprite,used_lcdbuffer,SPRT_AND);
        }
    }
*/

#ifdef USE_TI89
    asm volatile("
    move.w #0x5555,%%d0
    moveq #100-7-1,%%d1
    move.l used_lcdbuffer(%%pc),%%a0

  0:
    moveq #15-1,%%d2
    not.w %%d0

  1:
    and.w %%d0,(%%a0)+
    dbf %%d2,1b
/*
    moveq #15-1,%%d2
    not.w %%d0

  _loop2_2_:
    and.w %%d0,(%%a0)+
    dbf %%d2,_loop2_2_
*/
    dbf %%d1,0b
    " : : : "d0","d1","d2","a0");
#else
    asm volatile("
    move.w #0x5555,%%d0
    moveq #128-7-1,%%d1
    move.l used_lcdbuffer(%%pc),%%a0

  _loop1_:
    moveq #15-1,%%d2
    not.w %%d0

  _loop2_:
    and.w %%d0,(%%a0)+
    dbf %%d2,_loop2_
/*
    moveq #15-1,%%d2
    not.w %%d0

  _loop2_2_:
    and.w %%d0,(%%a0)+
    dbf %%d2,_loop2_2_
*/
    dbf %%d1,_loop1_
    " : : : "d0","d1","d2","a0");
#endif
/*
    WIN_RECT w = {x,y,x+width,y+height};
    SCR_RECT s = {{x,y,x+width,y+height}};
*/
    WIN_RECT w;
    SCR_RECT s;

    w.x0 = s.xy.x0 = x;

    w.y0 = s.xy.y0 = y;

    w.x1 = s.xy.x1 = x+width;

    w.y1 = s.xy.y1 = y+height;


    ScrRectFill(&s,&fullscreen,A_REVERSE);
    DrawClipRect(&w,&fullscreen,A_NORMAL);

    if (title) {
        s.xy.y1 = s.xy.y0+6;
        ScrRectFill(&s,&fullscreen,A_NORMAL);
        DrawStr(x+((width-FastStringWidth(title))>>1),y+1,title,A_REVERSE);
    }
}


/*===========================================================================*/
/* inverts a menu entry                                                      */
/*===========================================================================*/
void InvertSelectionPopupEntry(short idx,SCR_RECT* s) {
//    SCR_RECT fe = {{s->xy.x0,s->xy.y0+idx*8,s->xy.x1,s->xy.y0+(idx+1)*8-2}};

// New smaller construct.
    SCR_RECT fe = *s;

    fe.xy.y0 += idx*8;

    fe.xy.y1 = fe.xy.y0 + 8 - 2;


    ScrRectFill(&fe,&fullscreen,A_XOR);
}


/*===========================================================================*/
/* draws and handles an input field for 8 characters                         */
/* returns 1 if successful                                                   */
/*===========================================================================*/
short is_password = 0;
short DrawAndHandleInputField(short x,short y,char* buffer) {
    short    count = 0;
    unsigned short input;
    short    redraw = 0;

/*
    WIN_RECT w     = {x,y,x+8*6+2,y+8};
    SCR_RECT s     = {{w.x0+1,w.y0+1,w.x1-1,w.y1-1}};
*/

// New smaller construct.
    WIN_RECT w;
    SCR_RECT s;

    w.x0 = x;
    s.xy.x0 = x+1;

    w.y0 = y;
    s.xy.y0 = y+1;

    s.xy.x1 = x+8*6+1;
    w.x1 = x+8*6+2;

    s.xy.y1 = y+7;
    w.y1 = y+8;


    ScrRectFill(&s,&fullscreen,A_REVERSE);
    DrawClipRect(&w,&fullscreen,A_NORMAL);

    do {
        input = tolower(GetUserInput());
        if (input == KEY_ESC) return 0;
        else if (input == KEY_ENTER) {
            if (buffer[0]) return 1;
            else           return 0;
        }
        else if ((input >= 'a' && input <= 'z') || (input >= '0' && input <= '9')) {
            if (count < 8) {
                buffer[count++] = input;
                buffer[count]   = 0;
                redraw++;
            }
        }
        else if (input == KEY_BACKSPACE || input == KEY_LEFT) {
            if (count > 0) {
                count--;
                buffer[count] = 0;
                redraw++;
            }
        }
        else if (input == KEY_CLEAR) {
            count = 0;
            memset(buffer,0,8);
            redraw++;
        }

        if (redraw) {
            ScrRectFill(&s,&fullscreen,A_REVERSE);
            if (is_password) {
                char* tmp = buffer;
                int   i=0;
                while (*tmp) {
                    DrawChar(x+1+i,y+2,'*',A_REPLACE);
                    i+=6;
                    tmp++;
                }
            }
            else {
                FastStringXY(x+1,y+2,buffer);
            }
            redraw = 0;
        }

    }
    while (1);
}



#ifdef USE_TI89
static inline unsigned short MapTI89Numbers(unsigned short input) {
    switch(input) {
        case 'v': return '0';
        case 'q': return '1';
        case 'r': return '2';
        case 's': return '3';
        case 'l': return '4';
        case 'm': return '5';
        case 'n': return '6';
        case 'g': return '7';
        case 'h': return '8';
        case 'i': return '9';
        default:  return input;
    }
}
#endif

/*===========================================================================*/
/* handles a selection popup                                                 */
/* returns selected index or -1                                              */
/*===========================================================================*/
short HandleSelectionPopup(short xpos,short ypos,const char* entries[],const char* shortcuts[]) {
    SCR_RECT   s;
    unsigned short nr_entries = 0;
    unsigned short i;
    short      max_width = 0;
    short      idx = 0;

    // Find maximum width
    while (entries[nr_entries] != NULL) {
        short tmp = FastStringWidth(entries[nr_entries]);
        if (shortcuts) tmp += FastStringWidth(shortcuts[nr_entries]);
        if (tmp > max_width) max_width = tmp;
        nr_entries++;
    }

    if (xpos == -1) xpos = (C89_92(160,240)-max_width)/2;

    s.xy.x0 = xpos+1;
    s.xy.y0 = ypos+1;
//    s.xy.y0 = ypos;
    s.xy.x1 = xpos+max_width+3;
    s.xy.y1 = ypos+nr_entries*8;

    DrawWindow(xpos,ypos,max_width+4,nr_entries*8,NULL);

    xpos++;
    ypos += 2;
    for (i=0;i<nr_entries;i++) {
        DrawStr(xpos,ypos+i*8,entries[i],A_NORMAL);
        if (shortcuts) DrawStr(xpos+max_width-FastStringWidth(shortcuts[i]),
                               ypos+i*8,shortcuts[i],A_NORMAL);
    }

/*
    s.xy.y0+=2;
    for (i=0;i<nr_entries;i++) {
        DrawStr(s.xy.x0,s.xy.y0+i*8,entries[i],A_NORMAL);
        if (shortcuts) DrawStr(s.xy.x0+max_width-FastStringWidth(shortcuts[i]),
                               s.xy.y0+i*8,shortcuts[i],A_NORMAL);
    }

    s.xy.y0--;
*/

    InvertSelectionPopupEntry(idx,&s);

    do {
        i = GetUserInput();
        if (i==KEY_DOWN) {
            InvertSelectionPopupEntry(idx,&s);
            idx++;
            if (idx>=(short)nr_entries) idx=0;
            InvertSelectionPopupEntry(idx,&s);
        }
        else if (i==KEY_UP) {
            InvertSelectionPopupEntry(idx,&s);
            idx--;
            if (idx < 0) idx = nr_entries-1;
            InvertSelectionPopupEntry(idx,&s);
        }
#if defined(USE_TI89)
        i = MapTI89Numbers(i);
#endif
        if (i >= '1' && i <= '9') return i-'1';
        else if (i=='0')          return 9;
    }

    while (i != KEY_ESC && i != KEY_ENTER);

    if (i == KEY_ENTER) return idx;
    else                return -1;
}


//=============================================================================
// draws info page
//=============================================================================
#define INFO_X 65
unsigned short DrawInfoPage(void) {
    short         i;
    char          sbuffer[100];
// Can date_and_time be optimized ?
    static char   date_and_time[] = __DATE__" "__TIME__;
    unsigned long inUse;
    unsigned long freeAfterGC;
    unsigned long freeB;
#if defined(INCLUDE_EASTER_EGG)
    short         first = 1;
#endif
    // Work around the fact -fno-function-cse is needed to be able to use
    // F-Line ROM_CALLs...
    void (*ptr)(register short asm("%d0"),register short asm("%d1"),register const unsigned char* asm("%a0"));

    ptr = FastStringXY;

    DrawWindow(OFFSET_X,OFFSET_Y,159,93," ");
    DrawStatusLine(NULL);

    DrawStr(OFFSET_X+2,1+OFFSET_Y,GetMsg(MSG_PRGTITLE),A_REVERSE);
    DrawStr(158-FastStringWidth(date_and_time)+OFFSET_X,1+OFFSET_Y,date_and_time,A_REVERSE);

    for (i=0;i<10;i++) {
        (*ptr)(OFFSET_X+2,i*8+9+OFFSET_Y,infopage[i]);
    }

    sprintf(sbuffer,MSGDIRECT_NUMFILES,folder_list[active_folder].name,file_count);

    (*ptr)(INFO_X+OFFSET_X,0*8+9+OFFSET_Y,sbuffer);

    if (global_mode==SCROLL_FILE) {
        SYM_ENTRY* entry;
        unsigned char* src;
        unsigned char* name = file_list[active_file].name;
        unsigned short length;

        entry = SymFindPtr(GenerateTIOSName(name,sbuffer),0);
        if (entry && entry->handle) {
            src = HeapDeref(entry->handle);
            length = *(unsigned short*)(src)+2;
            sprintf(sbuffer,MSGDIRECT_FILESIZE,name,length);
            (*ptr)(INFO_X+OFFSET_X,1*8+9+OFFSET_Y,sbuffer);
            sprintf(sbuffer,"%u -> 0x%lX (%s)",entry->handle,(unsigned long)src,
                    ((HeapGetLock(entry->handle))?MSGDIRECT_FILELOCKED:MSGDIRECT_FILEMOVABLE));
        }
    }
    else {
        SYM_ENTRY* entry;
        unsigned char* src;
        unsigned char* name = folder_list[active_file].name;

        entry = DerefSym(SymFindHome(GenerateTIOSName(name,sbuffer)));
        if (entry && entry->handle) {
            src = HeapDeref(entry->handle);
            sprintf(sbuffer,"%u -> 0x%lX (%s)",entry->handle,(unsigned long)src,
                    ((HeapGetLock(entry->handle))?MSGDIRECT_FILELOCKED:MSGDIRECT_FILEMOVABLE));
        }
    }

    (*ptr)(INFO_X+OFFSET_X,2*8+9+OFFSET_Y,sbuffer);


    {
        file_t * ptr2 = &file_list[active_file];
        if (global_mode==SCROLL_FILE) {
            sprintf(sbuffer,"%s / %s",ptr2->ext,ptr2->comment);
        }
    }

    (*ptr)(INFO_X+OFFSET_X,3*8+9+OFFSET_Y,sbuffer);

    sprintf(sbuffer,"%d",FreeHandles());
    (*ptr)(INFO_X+OFFSET_X,4*8+9+OFFSET_Y,sbuffer);

    HeapCompress(); // compress heap first !!!
    sprintf(sbuffer,MSGDIRECT_MEMSIZE,HeapAvail());
    (*ptr)(INFO_X+OFFSET_X,5*8+9+OFFSET_Y,sbuffer);

    EM_survey(&inUse,&freeAfterGC,&freeB,NULL,NULL,NULL);

    sprintf(sbuffer,MSGDIRECT_MEMSIZE,inUse);
    (*ptr)(INFO_X+OFFSET_X,6*8+9+OFFSET_Y,sbuffer);
    sprintf(sbuffer,MSGDIRECT_MEMSIZE,(freeB+freeAfterGC));
    (*ptr)(INFO_X+OFFSET_X,7*8+9+OFFSET_Y,sbuffer);
    sprintf(sbuffer,"0x%lX",(unsigned long)top_estack);
    (*ptr)(INFO_X+OFFSET_X,8*8+9+OFFSET_Y,sbuffer);
/*    sprintf(sbuffer,"%lu",  (unsigned long)HeapSize(pti->tictex_handle)
                          + (unsigned long)HeapSize(HeapPtrToHandle((char *)__ld_entry_point-2))
//                          + (unsigned long)HeapSize(HeapPtrToHandle((char *)&__ld_entry_point-2))
                          + folder_count*sizeof(folder_t)
                          + file_count*sizeof(file_t)
                          + LCD_SIZE // LCD save in tictex.
                          + 220 + 168 // Save stack in tictex - MUST BE MODIFIED IF THAT CHANGES
                          );
    (*ptr)(INFO_X+OFFSET_X,9*8+9+OFFSET_Y,sbuffer);
*/
    DrawBatteryState(INFO_X+OFFSET_X,9*8+9+OFFSET_Y);
#if defined(INCLUDE_EASTER_EGG)
    // very dumb easter egg - just inverts the screen if F3 is pressed
    do {
        unsigned short s = GetUserInput();
        unsigned long* ptr;
        if (s!=KEY_F3) return s;
        if (first) {
            (*ptr)(OFFSET_X+2,9*8+11+OFFSET_Y,
                         "Congratulations: You've found the Easter Egg");
            first = 0;
        }
        for (i=960+1,ptr=LCD_MEM;(i--);ptr++) *ptr = ~(*ptr);
    } while (1);
#else
    return GetUserInput();
#endif
}


//=============================================================================
// draws the about dialog
//=============================================================================
unsigned short DrawAboutDialog(void) {
    short i;
    short add_off = 0;

    // MSG_PRGTITLE is precisely equal to TICTEX_VERSION_STRING (see
    // definition in messages.c).
    // However, replacing GetMsg(MSG_PRGTITLE) with TICTEX_VERSION_STRING
    // generates bigger code (?!).
    DrawWindow(OFFSET_X+25, OFFSET_Y+13,110,72,GetMsg(MSG_PRGTITLE));
    DrawLine(OFFSET_X+30,OFFSET_Y+65,OFFSET_X+130,OFFSET_Y+65,A_REPLACE);

    for (i=0;i<7;i++) {
        if (i<5) add_off = 0;
        else     add_off = 5;
        FastStringXY(OFFSET_X+(160-FastStringWidth(about[i]))/2,
                     OFFSET_Y+24+i*8+add_off,about[i]);
    }

    return GetUserInput();
}


/*===========================================================================*/
/* shows the help page                                                       */
/*===========================================================================*/
unsigned short DrawHelpPage(void) {
    short i      = 0;

    DrawWindow(OFFSET_X,OFFSET_Y,159,93," ");
    DrawStatusLine(NULL);

    DrawStr(OFFSET_X+2,1+OFFSET_Y,GetMsg(MSG_PRGTITLE),A_REVERSE);
    DrawStr(158-FastStringWidth(MSGDIRECT_HELPTITLE)+OFFSET_X,1+OFFSET_Y,MSGDIRECT_HELPTITLE,A_REVERSE);

// Assume number of strings in helppage is a multiple of 2.
    for (i=0;i<6;i++) {
        FastStringXY(OFFSET_X+2,i*8+9+OFFSET_Y,helppage[i*2]);
        FastStringXY(65+OFFSET_X,i*8+9+OFFSET_Y,helppage[i*2+1]);
    }

    return GetUserInput();
}

/*===========================================================================*/
/* handle password                                                           */
/*===========================================================================*/
short HandlePassword(short mode) {
    short retval;
    char  buffer[20];
    static const char offsets[9] = "TICTEXP";
    char *ptr,*ptr2;

    ptr = buffer;
    for (retval=20;(retval--);) *ptr++ = 0;


    if (mode == PASSWORD_TEST) {
        DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_TESTPASSWORD);
    }
    else {
        DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_ENTERNEWPASSWORD);
    }
    FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_PASSWORD);

    is_password = 1;
    retval = DrawAndHandleInputField(OFFSET_X+79,OFFSET_Y+40,buffer);
    is_password = 0;

    if (!retval) return 0;

    if (mode == PASSWORD_CHANGE) {
        DrawWindow(OFFSET_X+25,OFFSET_Y+30,110,22,MSGDIRECT_REENTERPASSWORD);
        FastStringXY(OFFSET_X+30,OFFSET_Y+42,MSGDIRECT_PASSWORD);
        is_password = 1;
        retval = DrawAndHandleInputField(OFFSET_X+79,OFFSET_Y+40,buffer+10);
        is_password = 0;
        if (!retval || strcmp(buffer,buffer+10)) return 0;
    }

    ptr = buffer+1; ptr2 = (char*)offsets+1;
    for (retval=1;retval<8;retval++) *ptr++ ^= *ptr2++;
//    for (retval=1;retval<8;retval++) buffer[retval] ^= offsets[retval];

/*
    ptr = buffer;
    *((unsigned long *)ptr++) ^= 0x54494354; *((unsigned long *)ptr) ^= 0x45585000;
*/

    if (mode == PASSWORD_TEST) return (!memcmp(configuration.pwd,buffer,9));
    memcpy(configuration.pwd,buffer,9);

    return 1;
}



//=============================================================================
// Revision History
//=============================================================================
//
// $Log: menu.c,v $
// Revision 1.13  2002/09/23 09:37:38  tnussb
// generic commit (see history.txt: changes up to v1.30 Beta 7)
//
// Revision 1.12  2002/02/25 12:54:45  tnussb
// minor size optimizations and beautifying
//
// Revision 1.11  2002/02/07 18:01:17  tnussb
// generic commit
//
// Revision 1.10  2001/02/10 10:25:29  Thomas Nussbaumer
// unnecessary code removed
//
// Revision 1.9  2001/02/04 13:11:27  Thomas Nussbaumer
// changes up to version 1.00 RC2 (see history.txt)
//
// Revision 1.8  2001/01/26 21:04:44  Thomas Nussbaumer
// changes for version 0.80 [see history.txt]
//
// Revision 1.7  2001/01/21 00:20:16  Thomas Nussbaumer
// additionally changes related to version 0.60
//
// Revision 1.6  2001/01/20 21:36:30  Thomas Nussbaumer
// changes due to version 0.60
//
// Revision 1.5  2001/01/17 23:38:41  Thomas Nussbaumer
// changes related to version 0.50 (see history.txt)
//
// Revision 1.4  2001/01/16 03:42:25  Thomas Nussbaumer
// see history.txt (up to version 0.40)
//
// Revision 1.3  2001/01/15 00:08:19  Thomas Nussbaumer
// see history.txt (up to v0.34) for what's new
//
// Revision 1.2  2001/01/06 23:15:29  Thomas Nussbaumer
// see history.txt file for changes (new in v0.27 till v0.29)
//
// Revision 1.1  2001/01/03 19:32:00  Thomas Nussbaumer
// initial version
//
//
//
