/******************************************************************************
*
* project name:  TICT-Explorer
* file name:     protect.c
* initial date:  16/01/2001
* author:        thomas.nussbaumer@gmx.net
*
* description:   anticrash handler ported from DoorOS 0.98 source code
*                extended by FLINE 1111 support by Greg Dietsche (taken from
*                KernNO 3.1)
*
* $Id: protect.c,v 1.4 2002/09/10 11:28:42 tnussb Exp $
*
******************************************************************************/

#include <tigcclib.h>
#include "protect.h"

extern void exceptionhandlers(void);

#if defined(FLINE1111SUPPORT)

// That's a shame we cannot factor out (as the first instruction after label crash) that move to SR...
asm (
".text\n"\
"exceptionhandlers:\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #0,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #1,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #2,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #3,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #4,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #5,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #6,%d0\n"\
"    jbra    crash\n"\
"    nop\n"\
"    nop\n"\
"    nop\n"\
"    jbra    __line1111_emulator__\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #8,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #9,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #10,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #11,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #12,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #13,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #14,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #15,%d0\n"\
"crash:\n"\
"    move.w  %d0,exception_occured\n"\
"    move.w  #0x700,%sr\n | user mode, no interrupts\n"\
"    dc.w    0xa006 | trigger line1010 exception with value 0x6 -> throws exception!\n"\
"__line1111_emulator__:\n"\
"    movem.l %a0-%a1/%d0,-(%sp) | saving registers for bra/bsr w/long word displacement emulation\n"\
"    move.l  14(%sp),%a0        | get the old pc\n"\
"    moveq.l #0,%d0             | clear all of d0...it may be used in long addition (moveq is faster than clr)\n"\
"    move.w  (%a0),%d0          | get the instruction that caused the interrupt\n"\
"    addq.l  #2,%a0             | go past the 2 byte 1111Emulator Code; point to the accompanying data/or next instruction\n"\
"    move.l  0xc8,%a1           | initialize rom call table pointer\n"\
"    cmpi.w  #0xFFF0,%d0        | 6 byte bsr w/long word displacement  ($FFF0)\n"\
"    bne.s   __NotFFF0\n"\
"    move.l  %a0,%a1            | a1=a0=pc\n"\
"    adda.l  (%a0)+,%a1         | a1+displacment=new pc=function address\n"\
"    move.l  %a1,14(%sp)        | save new pc (return address for _this_ interrupt)\n"\
"    bra.s   __Quit1111\n"\
"__NotFFF0:                     | 6 byte bra w/long word displacement ($FFF1)\n"\
"    cmpi.w  #0xFFF1,%d0\n"\
"    bne.s   __NotFFF1\n"\
"    adda.l  (%a0),%a0\n"\
"    move.l  %a0,14(%sp)\n"\
"    movem.l (%sp)+,%a0-%a1/%d0 | ti saves registers, so i do too. What about condition code flags??\n"\
"    rte\n"\
"__NotFFF1:\n"\
"    cmpi.w  #0xFFF2,%d0        | 4 byte ROM CALL     ($FFF2)\n"\
"    bne.s   __NotFFF2\n"\
"    move.w  (%a0),%d0\n"\
"    lsr.w   #2,%d0             | divide by 4 to get the rom call index\n"\
"    cmp.l   -4(%a1),%d0        | handle a rom call index greater than the total # avail\n"\
"    bgt.s   __Bad1111          | rom calls as a crash. Would calling the AMS emulator be better...\n"\
"    lsl.w   #2,%d0\n"\
"    move.l  0(%a1,%d0),14(%sp)\n"\
"    addq.l  #2,%a0             | set pc to the correct location (old pc + 4)\n"\
"    bra     __Quit1111\n"\
"__NotFFF2:\n"\
"    subi.w  #0xF800,%d0        | 2 byte ROM CALL     ($F800 + Rom Call)\n"\
"    bmi.s   __Bad1111          | branch if less than zero (blt #$F800)\n"\
"    cmp.l   -4(%a1),%d0        | currently, handle a rom call index greater than the total # avail\n"\
"    bgt     __Bad1111          | rom calls as a crash. Would calling the AMS emulator be better....\n"\
"    lsl.l   #2,%d0             | *4\n"\
"    move.l  0(%a1,%d0),14(%sp) | save new pc (return address for _this_ interrupt)\n"\
"__Quit1111:\n"\
"    move    %usp,%a1\n"\
"    move.l  %a0,-(%a1)         | a0.l = return address to push on user stack\n"\
"    move    %a1,%usp\n"\
"    movem.l (%sp)+,%a0-%a1/%d0\n"\
"    rte\n"\
"    | rte calls the rom call, the rom call will return to the program that\n"\
"    | called it thru the return address pushed on the user stack. \n"\
"__Bad1111:\n"\
"    | note to self, if displaying regs for debug info, they must be restored...\n"\
"    lea     18(%sp),%sp        | restore supervisor stack (6 + 12)\n"\
"    moveq  #7,%d0\n"\
"    jbra    crash");

#else
#error The tictexpl part of TICT-Explorer 1.40+ requires F-Line ROM_CALL support to run.

asm (
".text\n"\
"exceptionhandlers:\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #0,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #1,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #2,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #3,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #4,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #5,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #6,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #7,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #8,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #9,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #10,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #11,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #12,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #13,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #14,%d0\n"\
"    jbra    crash\n"\
"    move.w  #0x2700,%sr\n"\
"    moveq  #15,%d0\n"\
"crash:\n"\
"    move.w  %d0,exception_occured\n"\
"    move.w  #0x700,%sr\n"\
"    dc.w    0xa006");    // trigger line1010 exception with value 0x6 -> throws exception!

#endif


extern unsigned char vec_offsets[16];
asm("
.text
.xdef vec_offsets
vec_offsets:
.byte 0xC            | ADDRESS ERROR
.byte 0x10           | ILLEGAL INSTRUCTION
.byte 0x14           | DIV BY ZERO
.byte 0x18           | CHK
.byte 0x1C           | TRAPV
.byte 0x20           | PRIV VIOLATION
.byte 0x24           | TRACE
.byte 0x2C           | LINE 1111
.byte 0x60           | SPURIOUS
.byte 0x7C           | MEMORY VIOLATION
.byte 0x80+4*5       | TRAP 5
.byte 0x80+4*6       | TRAP 6
.byte 0x80+4*7       | TRAP 7
.byte 0x80+4*13      | TRAP 13
.byte 0x80+4*14      | TRAP 14
.byte 0x80+4*15      | TRAP 15 : ER_Throw
");


//=============================================================================
// backups interrupts 1-7 and install special error vectors
// if you nesting this calls
//=============================================================================
void InstallCrashProtection(PROTECTION_T* backup) {
    asm volatile("
    | Interrupts off
    move.w #0x0700,%%d0
    trap #1
    " : : : "d0","d1","d2","a0","a1","cc");

    asm volatile("
    | Write unprotect vector table
    bclr #2,0x600001

    | Save the 7 auto-ints
    move.l %0,%%a0
|    move.l (%0),%%a0
    lea (16+7)*4(%%a0),%%a0
    lea (0x64+4*7).w,%%a1

    moveq #7-1,%%d0
    0:
    move.l -(%%a1),-(%%a0)
    dbf %%d0,0b

    | Save / install exception vectors
    lea (vec_offsets+16)(%%pc),%%a2
    lea (exceptionhandlers+8*15)(%%pc),%%a3
    moveq #16-1,%%d0
    1:
    moveq #0,%%d1
    move.b -(%%a2),%%d1
    move.l %%d1,%%a1 | unsigned long **vector = (unsigned long **)(unsigned long)vec_offsets[i];
    move.l (%%a1),-(%%a0) | (*backup)[i] = (unsigned long)*vector;
    move.l %%a3,(%%a1)
    lea -8(%%a3),%%a3
    dbf %%d0,1b

    | Write protect vector table
    bset #2,0x600001
    " : : "a"(backup) : "d0","d1","d2","a0","a1","a2","a3","cc","memory");

/*

    memcpy(&((*backup)[16]),(void*)0x00064, 7*4); // Saves the 7 auto_ints

    while (i--) {
        unsigned long **vector = (unsigned long **)(unsigned long)vec_offsets[i];
        (*backup)[i] = (unsigned long)*vector;
        *vector      = (unsigned long *)((unsigned short*)exceptionhandlers+5*i);
    }
*/


    RESET_EXCEPTION();

    asm volatile("
    | Interrupts on
    clr.w %%d0
    trap #1
    " : : : "d0","d1","d2","a0","a1","cc");
}

//=============================================================================
// restores interrupts 1-7 and the error vectors
//=============================================================================
void RemoveCrashProtection(PROTECTION_T* backup) {
    asm volatile("
    | Interrupts off
    move.w #0x0700,%%d0
    trap #1
    " : : : "d0","d1","d2","a0","a1","cc");

    asm volatile("
    | Write unprotect vector table
    bclr #2,0x600001

    | Restore the 7 auto-ints
    move.l %0,%%a0
|    move.l (%0),%%a0
    lea 23*4(%%a0),%%a0
    lea 0x80.w,%%a1

    moveq #7-1,%%d0
    0:
    move.l -(%%a0),-(%%a1)
    dbf %%d0,0b

    | Restore saved exception vectors
    lea (vec_offsets+16)(%%pc),%%a2
    moveq #16-1,%%d0
    1:
    moveq #0,%%d1
    move.b -(%%a2),%%d1
    move.l %%d1,%%a1 | unsigned long **vector = (unsigned long **)(unsigned long)vec_offsets[i];
    move.l -(%%a0),(%%a1) | *vector = (unsigned long*)(*backup)[i];
    dbf %%d0,1b

    | Write protect vector table
    bset #2,0x600001
    " : : "a"(backup) : "d0","d1","d2","a0","a1","a2","cc","memory");

    asm volatile("
    | Interrupts on
    clr.w %%d0
    trap #1
    " : : : "d0","d1","d2","a0","a1","cc");
}


//#############################################################################
// Revision History
//#############################################################################
//
// $Log: protect.c,v $
// Revision 1.4  2002/09/10 11:28:42  tnussb
// changes up to v1.30 Beta 4 / examine history.txt for details
//
// Revision 1.3  2002/02/07 18:01:18  tnussb
// generic commit
//
// Revision 1.2  2001/01/26 21:04:44  Thomas Nussbaumer
// changes for version 0.80 [see history.txt]
//
// Revision 1.1  2001/01/20 21:33:37  Thomas Nussbaumer
// initial version
//
//
